import sys
from types import *
from java import lang
from java import util
from java import io

#_______Utilities__________
#------------------------------------------------------------------------------
# ret(obj) - return utility
#------------------------------------------------------------------------------
def ret(obj):
	return ((obj) and (obj) or "None")
#------------------------------------------------------------------------------
# ret(obj) - return utility
#------------------------------------------------------------------------------
def notEmpty(destination):
	if (destination!=None and len(destination)>0):
		return 'true'
	else:
		return 'false' 
#_______Functions__________


#----------------------
# Load a properties file into a Dictionary. 

#----------------------

def loadProperties (source):

	result = {}
	if type(source) == type(''): # name provided, use file
		source = io.FileInputStream(source)
	bis = io.BufferedInputStream(source)
	props = util.Properties()
	props.load(bis)
	bis.close()
	for key in props.keySet().iterator():
		result[key] = props.get(key)
	return result
	
#------------------------------------------------------------------------------
# Gets a property
#------------------------------------------------------------------------------

def getProperty (properties, name, default=None):
	return properties.get(name, default).replace('"', '').strip()
	
	
def getProperty(name):
	return props.get(name, None).replace('"', '').strip()


#------------------------------------------------------------------------------
# checkPrereqInstall - verify prereq installation
#------------------------------------------------------------------------------

def checkPrereqInstall(appName):
	method="checkPrereqInstall(appName):"
	print getProperty("scrName")+method+">>Enter"
	appString = AdminApp.list()
	appList = appString.splitlines()

	indSDOInstalled ="false"
	for app in appList:
		if app.replace('"', '') == appName.replace('"', ''):
			indSDOInstalled="true"
			break
	if indSDOInstalled=="true":
		print getProperty("scrName")+method+"Application "+appName + " was found"
	else:
		print getProperty("scrName")+method+"Application "+appName + " was not found"				
	print getProperty("scrName")+method+"<<End:"+indSDOInstalled	
	return indSDOInstalled
#------------------------------------------------------------------------------
# checkCEIBus() Verifies if CommonEventInfrastructure_Bus exists
#------------------------------------------------------------------------------
def checkCEIBus():
	method="checkCEIBus():"
	print getProperty("scrName")+method+">>Enter"
	isCEIBus="false"
	busesString = AdminTask.listSIBuses()
	if len(busesString) != 0:
		busesList=busesString.splitlines() 
		for bus in busesList:
			busName = AdminConfig.showAttribute(bus,"name")
			if busName == getProperty("ceiBusName"):
				isCEIBus="true"
				break
	if isCEIBus=="true":
		print getProperty("scrName")+method+"Bus " + getProperty("ceiBusName") + " was found"
	else:
		print getProperty("scrName")+method+"Bus " + getProperty("ceiBusName") + " was not found"
	print getProperty("scrName")+method+"<<End:"+isCEIBus						
	return isCEIBus

#------------------------------------------------------------------------------
# createWSNService() Create WSN Service if it is not created
#------------------------------------------------------------------------------
def createWSNService():
	method="createWSNService():"
	print getProperty("scrName")+method+">>Enter"
	
	val="[-name " + getProperty("wsnServiceName")+ " -bus " + getProperty("ceiBusName")+" -permitsDynamicNamespace false -requiresRegistration false]"
	
	service=AdminTask.createWSNService(val) 
	#AdminConfig.save();
	print getProperty("scrName")+method+"WSN Service "+service+"was created"
	print getProperty("scrName")+method+"<<End:"+ret(service)
	return service

#------------------------------------------------------------------------------
# createSIBWSEndpointListener() Create an Endpoint listener
#------------------------------------------------------------------------------
def createSIBWSEndpointListener():
	method="createSIBWSEndpointListener():"
	print getProperty("scrName")+method+">>Enter"
	val="[-name "+getProperty("epListenerName")+" -urlRoot https://"+getProperty("host")+":"+getProperty("wsnPort")+"/"+getProperty("epListenerName")+" -wsdlUrlRoot http://www.ibmcompany.com/"+getProperty("epListenerName")+"/sibws]"
	print "crtServer: {" + crtServer + "}"
	print "val: {" + val + "}"

	epListenerOld=AdminTask.createSIBWSEndpointListener(crtServer, val) 
	AdminConfig.save();
	#epListenerOld = "WSNEndpointListenerHTTP(cells/LP02UT11_testingro/nodes/LP02UT11_testingro/servers/testingro|sibws-epl.xml#SIBWSEndpointListener_1156248192430)"
        # Verifies if the created applications are started and if not start them 
	appString = AdminApp.list()
	appList = appString.splitlines()

	for app in appList:
		tmp = 'WebSphere:type=Application,name=' + app + ',*'
		appName = AdminControl.queryNames(tmp)
		if (app == app1  or app == app2) and (len(appName)==0):
			print "4"
			am = AdminControl.queryNames('type=ApplicationManager,process=' + crtServerName + ',*')
			print "am: {" + am + "}" + "; app:{" + app + "}"
			val_start_app2= AdminControl.invoke(am,'startApplication',"["+ app + "]" ,'[java.lang.String]' )
			print "2"
	print "1"		
	print getProperty("scrName")+method+"End point listener was created "+epListenerOld
	print getProperty("scrName")+method+"<<End:"+ret(epListenerOld)
	return epListenerOld

#------------------------------------------------------------------------------
# createWSNServicePoint() Create WSN Service Point if it is not created
#------------------------------------------------------------------------------
def createWSNServicePoint(service):
	method="createWSNServicePoint(service):"
	print getProperty("scrName")+method+">>Enter"
	val="[-name "+ getProperty("wsnServicePointName")+" -node " +crtNodeName+ " -server "+ crtServerName +" -eplName "+getProperty("epListenerName")+"]"
	servicePoint=AdminTask.createWSNServicePoint(service,val)
	#AdminConfig.save();
	print getProperty("scrName")+method+"Service point "+servicePoint+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(servicePoint)
	return servicePoint


#--------------------------------------------------------------
# createSIBDestination Create SIB Destnation 
#--------------------------------------------------------------	
def createSIBDestination():
	method="createSIBDestination():"
	print getProperty("scrName")+method+">>Enter"
	val="[-bus "+getProperty("ceiBusName")+" -name "+ getProperty("ceiBusTopicDestinationName")+" -type TopicSpace -description -reliability ASSURED_PERSISTENT]"
	
	destination = AdminTask.createSIBDestination(val)
	print getProperty("scrName")+method+"SIBDestination "+destination+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(destination)
	return destination 	

#--------------------------------------------------------------
# createSIBDestination Create WSN Topic Namespace 
#--------------------------------------------------------------	
def createWSNTopicNamespace(service):
	method="createWSNTopicNamespace(service):"
	print getProperty("scrName")+method+">>Enter"
	val="[-namespace http://www.ibmcompany.com/"+getProperty("ceiBusTopicDestinationName")+" -busTopicSpace "+getProperty("ceiBusTopicDestinationName")+"]"
	topicNS=AdminTask.createWSNTopicNamespace(service,val)
	print getProperty("scrName")+method+"WSN Topic Namespace "+topicNS+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(topicNS)
	return topicNS 	

#--------------------------------------------------------------
# createSIBJMSTopic() Create a new JMS Topic 
#--------------------------------------------------------------	
def createSIBJMSTopic():
	method="createSIBJMSTopic():"
	print getProperty("scrName")+method+">>Enter"
	val="[-name "+getProperty("jmsName")+" -jndiName "+getProperty("jmsJNDI")+" -topicSpace " +getProperty("ceiBusTopicDestinationName")+ " -topicName "+getProperty("jmsTopicName")+" -busName "+ getProperty("ceiBusName")+"]"
	topic=AdminTask.createSIBJMSTopic(crtServer,val)
	print getProperty("scrName")+method+"JMS Topic "+topicNS+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(topic)
	
	return topic 		
#------------------------------------------------------------------
# createSIBJMSTopic() Create a new JMS TopicPub 
#------------------------------------------------------------------	
def createSIBJMSTopicPub():
	method="createSIBJMSTopicPub():"
	print getProperty("scrName")+method+">>Enter"
	val="[-name "+getProperty("jmsNamePub")+" -jndiName "+getProperty("jmsJNDIPub")+" -topicSpace " +getProperty("ceiBusTopicDestinationName")+ " -topicName "+getProperty("jmsTopicNamePub")+" -busName "+ getProperty("ceiBusName")+"]"
	topicpub=AdminTask.createSIBJMSTopic(crtServer,val)
	print getProperty("scrName")+method+"JMS Topic Pub"+topicNS+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(topicpub)
	return topicpub 		
#--------------------------------------------------------------
# createSIBJMSActivationSpec() Create a new JMS Activation Spec
#--------------------------------------------------------------	
def createSIBJMSActivationSpec():
	method="createSIBJMSActivationSpec():"
	print getProperty("scrName")+method+">>Enter"
	#Currently we have no security
        #	asAuthenticationAlias=""
	
	val="[-name "+getProperty("asName")+  " -jndiName "+getProperty("asJNDI")+ " -destinationJndiName "+getProperty("jmsJNDI")+" -authenticationAlias "+ getProperty("asAuthenticationAlias") + " -destinationType Topic -busName "+getProperty("ceiBusName")+"]"
	as=AdminTask.createSIBJMSActivationSpec(crtServer,val)
	print getProperty("scrName")+method+"Activation Spec "+as+" was created"
	print getProperty("scrName")+method+"<<End:"+ret(as)
	return as 			



def installEventServerMdb():
	method="installEventServerMdb():"
	print getProperty("scrName")+method+">>Enter"
	options = ['-usedefaultbindings','-defaultbinding.force','-verbose',\
           '-BindJndiForEJBMessageBinding ',[['EventServerMdb','EventBusMdbBean','EventServerMdb.jar,META-INF/ejb-jar.xml','',getProperty("asJNDI"),'']],\
           '-appname','EventServerMdb',\
           '-distributeApp',' -createMBeansForResources']
	createEventServerMdb=AdminApp.install(getProperty("EventServiceMdb"), options)

	# set once more the Target Resource JNDI Name to the correct value
	AdminApp.edit('EventServerMdb', '[  -MapEJBRefToEJB [[ EventServerMdb EventBusMdbBean EventServerMdb.jar,META-INF/ejb-jar.xml ejb/com/ibm/events/bus/EventBus com.ibm.events.bus.EventBusLocal ejb/com/ibm/events/bus/EventBus ]]]' )

	print "The application EventServerMdb was installed successfully"


def createEventGroupProfile():
	
        #------------------------
        #listing the Event Server
        #------------------------
	stringEventService=AdminConfig.list("EventServerProfile")
	listEventService=stringEventService.splitlines()
        #------------------------
        #finding the proper Event Service
        #------------------------
	for everyEventService in listEventService:
		showEventServerName=AdminConfig.showAttribute(everyEventService,"name")
		if showEventServerName==getProperty("EventServerName"):
			print "Event service "+showEventServerName + " was found\n"
			customEventServer="true"
			properEventService=everyEventService
			break

        #------------------------
        #listing the EventGroupProfile	
        #------------------------

	if customEventServer=="true":	
		stringEventGroupProfile=AdminConfig.list("EventGroupProfile")
		listEventGroupProfile = stringEventGroupProfile.splitlines()		
		for everyEventGroupProfile in listEventGroupProfile:
			showEventGroupName=AdminConfig.showAttribute(everyEventGroupProfile,"eventGroupName")
			if showEventGroupName ==getProperty("EventGroupName"):
				idEventGroupProfile=everyEventGroupProfile
				print "EventGroupProfile"+idEventGroupProfile+"was found"
				break
				
		global idEventGroupProfile
		if idEventGroupProfile==None:				
			attributes=[['eventGroupName',getProperty("EventGroupName")],['eventSelectorString', getProperty("eventSelectorString")],['topicJNDIName',getProperty("topicJNDIName")],['topicConnectionFactoryJNDIName', getProperty("topicConnectionFactoryJNDIName")],['persistEvents',getProperty("persistEvents")]]
			idEmitterFactoryProfile = AdminConfig.getid('/Cell:' + getProperty('crtCellName') + '/Node:' + getProperty('crtNodeName') + '/Server:' + getProperty('crtServerName') + '/EventInfrastructureProvider :EventInfrastructureProvider/EventGroupProfileList:Event groups list')
			idEventGroupProfile = AdminConfig.create('EventGroupProfile',idEmitterFactoryProfile,attributes)
			print "EventGroupProfile " + getProperty("EventGroupName") + " was created"
			# AdminConfig.save()
			# set compatibility mode to false
                        custoId=None
                        propertySetId=None
                        customEventServer=None
                        properEventService=None
			setEventGroupCompatibilityMode( idEventGroupProfile)
                        
		else:
			print "The EventGroupProfile was found "


def setEventGroupCompatibilityMode( idEventGroupProfile):

        #------------------------
        #Show PropertySet	
        #------------------------
		print "idEventGroupProfile"+idEventGroupProfile			
		propertySetId=AdminConfig.showAttribute(idEventGroupProfile,"propertySet")
		if propertySetId== None:
			AdminConfig.create('J2EEResourcePropertySet',idEventGroupProfile,[])
			#AdminConfig.save()
			propertySetId=AdminConfig.showAttribute(idEventGroupProfile,"propertySet")
			resourceProperty=AdminConfig.showAttribute(propertySetId,"resourceProperties")
			print "ResourceProperty is in if: "+resourceProperty+"\n"
		else:
			resourceProperty=AdminConfig.showAttribute(propertySetId,"resourceProperties")
			print "ResourceProperty is in else: "+resourceProperty+"\n"
        #------------------------	
        #If there is no CustomProperty
        #------------------------
		if resourceProperty=="[]":
                        #------------------------
                        #if the Custom Property does not exist	 is created		
                        #------------------------
			AdminConfig.create("J2EEResourceProperty",propertySetId,[['description',getProperty("descriptionCompatibilityMode")],['name',getProperty("nameCompatibilityMode")],['value',getProperty("valueCompatibilityMode")],['type',getProperty("typeCompatibilityMode")]])
			#AdminConfig.save()
			print "Custom Property was created\n"
		else:			
			replaceresourceProperty= re.sub(r"(\[|\])", "", resourceProperty)
			print "Parsing result: "+replaceresourceProperty
			listResourceProperty= replaceresourceProperty.split(" ")

        #------------------------
        #search for the proper Custom Property	
        #------------------------
			for everyResourceProperty in listResourceProperty:
				nameCustomProperty=AdminConfig.showAttribute(everyResourceProperty,"name")
				if nameCustomProperty == getProperty("nameCustomProperties"):
					custoId=everyResourceProperty
					break
        #------------------------		
        #check if the value is false if not the value is set on false
        #------------------------
			if custoId!=None:
	 			valueCustomProperty=AdminConfig.showAttribute(custoId,"value")
		 		print "The CustomProperty value is: " + valueCustomProperty+"\n"
		 		if  valueCustomProperty!=getProperty("valueCompatibilityMode"):
	 				AdminConfig.modify(custoId,[['value',getProperty("valueCompatibilityMode")]])
	 				print "The value was changed to"+getProperty("valueCompatibilityMode")+ "\n"
		 			#AdminConfig.save()

                                #------------------------
                                #if the Custom Property does not exist, it is created		
                                #------------------------
			else:
				AdminConfig.create("J2EEResourceProperty",propertySetId,[['description',getProperty("descriptionCompatibilityMode")],['name',getProperty("nameCompatibilityMode")],['value',getProperty("valueCompatibilityMode")],['type',getProperty("typeCompatibilityMode")]])
				#AdminConfig.save()
				print "Custom Property was created\n"
		



	
#_______Main__________
#------------------------------------------------------------------------------
# Main entry point
#------------------------------------------------------------------------------
method="Main():"

#Loading the properties from the Properties file
if len(sys.argv)>=1:
	file = sys.argv[0]
else:
	print "Give the eventWSN.properties as parameter"

props = loadProperties(file)
print "Properties file: %s, contents:" % file
print props

print getProperty("scrName") + method + ">>Enter"
print getProperty("scrName")
print props
#Initialize global variables
#--Cell
crtCellName =  getProperty("crtCellName")
if crtCellName!=None:	
	crtCell = AdminConfig.getid("/Cell:" + crtCellName + "/")
if crtCell==None or crtCellName==None:
	crtCell=AdminConfig.list("Cell")
	crtCell=crtCell.splitlines()
	crtCell=crtCell[0]
	crtCellName=AdminConfig.showAttribute(crtCell,"name")	
print getProperty("scrName")+method+"Cell name:" + crtCellName
print getProperty("scrName")+method+"Cell:" + crtCell
#--Node
crtNodeName=None
crtNodeName = getProperty("crtNodeName")
if crtNodeName!=None:	
	crtNode = AdminConfig.getid("/Cell:" + crtCellName + "/Node:"+crtNodeName+"/")
if crtNode==None or crtNodeName==None:
	crtNode=AdminConfig.list("Node")
	crtNode=crtNode.splitlines()
	crtNode=crtNode[0]
	crtNodeName=AdminConfig.showAttribute(crtNode,"name")	
print getProperty("scrName")+method+"Node name:" + crtNodeName
print getProperty("scrName")+method+"Node:" + crtNode
#--Server
crtServerName =  getProperty("crtServerName")
if crtServerName!=None:	
	crtServer = AdminConfig.getid("/Cell:" + crtCellName + "/Node:"+crtNodeName+"/Server:"+crtServerName+"/")
if crtServer==None or crtServerName==None:
	crtServer=AdminConfig.list("Server")
	crtServer=crtServer.splitlines()
	crtServer=crtServer[0]
	crtServerName=AdminConfig.showAttribute(crtServer,"name")	
print getProperty("scrName")+method+"Server name:" + crtServerName
print getProperty("scrName")+method+"Server:" + crtServer


#WSNEndpointListener Variabile 
app1=getProperty("epListenerName")+"."+crtNodeName+"."+crtServerName
app2="sibws."+crtNodeName+"."+crtServerName 

#Verifies SDO prereq
sdo_app = getProperty("sdo_app")	
if checkPrereqInstall(sdo_app)!="true":
	sys.exit(0)

	
#Verifies CEI prereq	
if checkCEIBus()!="true":
	sys.exit(0)
#WSN objects
epListener = createSIBWSEndpointListener()
service = createWSNService()
servicePoint = createWSNServicePoint(service)
sibDestination=createSIBDestination()
topicNS = createWSNTopicNamespace(service)
#-------------3-----------
jmsTopic = createSIBJMSTopic()
jmsTopicPub = createSIBJMSTopicPub()
activationSpec = createSIBJMSActivationSpec()
#-------------4-----------
EventServerMdbear = installEventServerMdb()

idEventGroupProfile = None
customEventServer = None
properEventService = None

createEventGroupProfile = createEventGroupProfile()

AdminConfig.save()
print getProperty("scrName")+method+"<<End:"

