-- Licensed Materials - Property of IBM
-- 5724-M24
-- Copyright IBM Corporation 2007, 2012.  All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- ------------------------------------------------------------------
--
-- Scriptfile to create Oracle materialized view for showcase model
--
-- Run the script in SQL*Plus.
--
-- USAGE:  >sqlplus /nolog
--         SQL> conn /as sysdba
--         SQL> @createShowcaseMaterializedView.ddl
--
-- ------------------------------------------------------------------

----------------------------------------------------
-- Grant necessary privileges to showcase model user
----------------------------------------------------
GRANT CREATE ANY MATERIALIZED VIEW TO MORTGAGELENDINGBAMSHOWCASE;
GRANT QUERY REWRITE TO MORTGAGELENDINGBAMSHOWCASE;
ALTER SYSTEM SET QUERY_REWRITE_ENABLED = TRUE;
ALTER SYSTEM SET QUERY_REWRITE_INTEGRITY = ENFORCED;

--------------------------------------------------
-- Create materialized view log for table "TGT_DFCTMNTRMDL_MRTGGLNDNGB_20080918060000"
--------------------------------------------------
CREATE MATERIALIZED VIEW LOG ON MORTGAGELENDINGBAMSHOWCASE.TGT_MRTGGLNDNGB_20080918060000 TABLESPACE "MONDSTS" WITH ROWID, SEQUENCE("M_MORTGAGELENDING_KEY", "M_CURRENT_LENDING_PROCESSSTT"), PRIMARY KEY INCLUDING NEW VALUES;

----------------------------------------------
-- Create materialized view for showcase model
-- Replace your SQL in the below statement
----------------------------------------------
CREATE MATERIALIZED VIEW MV_MORTGAGELENDINGMODEL 
	TABLESPACE "MONDSTS" 
	USING INDEX TABLESPACE "MONIDXTS" 
	REFRESH FAST WITH ROWID ON COMMIT 
	ENABLE QUERY REWRITE
	AS 
	SELECT count(MORTGAGELENDINGBAMSHOWCASE.MCU_MORTGAGE_LENDING_BAM_MC.M_MORTGAGELENDING_KEY) FROM MORTGAGELENDINGBAMSHOWCASE.MCU_MORTGAGE_LENDING_BAM_MC WHERE ((UPPER(MORTGAGELENDINGBAMSHOWCASE.MCU_MORTGAGE_LENDING_BAM_MC.M_CURRENT_LENDING_PROCESSSTT) = 'LENDING PROCESS COMPLETED' ));

---------------------------------------------------------------------------
-- Analyze the materialized view after it is created.
-- Recommend this statement be run when DMS is enabled and not running
---------------------------------------------------------------------------
-- BEGIN DBMS_STATS.GATHER_TABLE_STATS(ownname =>'SYS', tabname => 'MV_MortgageLendingModel'); END;