#  Licensed Materials - Property of IBM
#  5724-M23, 5724-M24
#  Copyright IBM Corporation 2007, 2011. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java 

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

if (ndType == "managed"):
    try:
        cellName = AdminControl.getCell()
    except:
        print "warning: AdminControl may not be available."    

#Disable CEI Event datastore in production mode
if (isUTE != "true" and ndType != "dmgr"):
    try:
        #Identify the CEI provider ID at server scope.
        ceiProvider = AdminConfig.getid("/Cell:"+cellName+"/Node:"+nodeName+"/Server:"+serverName+"/EventInfrastructureProvider:/")
        print "ceiProvider ="+ceiProvider
    
        esps = AdminConfig.list("EventServerProfile",ceiProvider).splitlines()
        print "esps="+str(esps)
        
        defaultESPJndiName = "com/ibm/events/configuration/event-server/Default"
        defaultESP = esps[0]
    
        for i in range(len(esps)):
            if(len(esps[i])>0): 
               jndiName = AdminConfig.showAttribute(esps[i],"jndiName")
               print "jndiName ="+jndiName
               if(jndiName == defaultESPJndiName):
                   defaultESP = esps[i]
                   break
        
        if(defaultESP != None):
            print "defaultESP="+defaultESP
            attr = ["enableDataStore","false"]
            properties = [attr]
            AdminConfig.modify(defaultESP,properties)
            AdminConfig.save()  
    except:
        print "warning: Disable CEI Event datastore failed."    
            
#Create emitter factory
try:
    #Identify the CEI provider ID at Cell scope.
    ceiProvider = AdminConfig.getid("/Cell:"+cellName+"/EventInfrastructureProvider:/")
    print "ceiProvider ="+ceiProvider
    #Set the required attributes 
    name = ['name', emitterFactoryName]
    jndiName = ['jndiName',emitterFactoryJndi]
    description = ['description',emitterFactoryDesc] 
    synchronizationMode = ['preferredSynchronizationMode','true']
    syncJndiName = ['synchronousTransmissionProfileJNDIName', "cell/nodes/"+nodeName+"/servers/"+serverName+"/com/ibm/events/configuration/bus-transmission/Default"]
    filteringEnabled = ['filteringEnabled', 'false']
    #Set custom properties
    compatibilityName = ['name','compatibilityMode']
    compatibilityDescription = ['description','']
    compatibilityRequired = ['required', 'false']
    compatibilityType =  ['type','java.lang.Boolean']
    compatibilityValue = ['value','false']
    compatibilityMode = [compatibilityName,compatibilityDescription,compatibilityRequired,compatibilityType,compatibilityValue]
    customProperties = ['propertySet', [['resourceProperties',[compatibilityMode]]]]
    
    properties = [name,jndiName,description,synchronizationMode,syncJndiName,filteringEnabled,customProperties]
    
    print "properties ="+str(properties)
    
    print AdminConfig.create("EmitterFactoryProfile",ceiProvider,properties)
    AdminConfig.save()
except:
    print "warning: Create emitter factory failed."    

#Reconfigure Default EventBusTransmission jndiName to fully qualified name
try:
    #Identify the CEI provider ID at server scope.
    ceiProvider = AdminConfig.getid("/Cell:"+cellName+"/Node:"+nodeName+"/Server:"+serverName+"/EventInfrastructureProvider:/")
    print "ceiProvider ="+ceiProvider
    defaultEBTJndiName = "com/ibm/events/configuration/bus-transmission/Default"

    defaultEBT = None
    ebts = AdminConfig.list("EventBusTransmissionProfile",ceiProvider).splitlines()

    for i in range(len(ebts)):
        if(len(ebts[i])>0): 
           jndiName = AdminConfig.showAttribute(ebts[i],"jndiName")
           print "jndiName ="+jndiName
           if(jndiName == defaultEBTJndiName):
               defaultEBT = ebts[i]
               break

    if(defaultEBT != None):
        eventBusJNDIName = ['eventBusJNDIName','cell/nodes/'+nodeName+'/servers/'+serverName+'/ejb/com/ibm/events/bus/EventBus']
        properties = [eventBusJNDIName]
        AdminConfig.modify(defaultEBT,properties)
        AdminConfig.save()      
except:
    print "warning: Create emitter factory failed."    

#Create another emitter factory
try:
    #Identify the CEI provider ID at Cell scope.
    ceiProvider = AdminConfig.getid("/Cell:"+cellName+"/EventInfrastructureProvider:/")
    print "ceiProvider ="+ceiProvider
    #Set the required attributes 
    name = ['name', 'MonitorEmitterFactoryDefault']
    jndiName = ['jndiName','com/ibm/events/configuration/emitter/Default']
    description = ['description','MonitorEmitterFactoryDefault'] 
    synchronizationMode = ['preferredSynchronizationMode','true']
    syncJndiName = ['synchronousTransmissionProfileJNDIName', "cell/nodes/"+nodeName+"/servers/"+serverName+"/com/ibm/events/configuration/bus-transmission/Default"]
    filteringEnabled = ['filteringEnabled', 'false']
    #Set custom properties
    compatibilityName = ['name','compatibilityMode']
    compatibilityDescription = ['description','']
    compatibilityRequired = ['required', 'false']
    compatibilityType =  ['type','java.lang.Boolean']
    compatibilityValue = ['value','false']
    compatibilityMode = [compatibilityName,compatibilityDescription,compatibilityRequired,compatibilityType,compatibilityValue]
    customProperties = ['propertySet', [['resourceProperties',[compatibilityMode]]]]
    
    properties = [name,jndiName,description,synchronizationMode,syncJndiName,filteringEnabled,customProperties]
    
    print "properties ="+str(properties)
    
    print AdminConfig.create("EmitterFactoryProfile",ceiProvider,properties)
    AdminConfig.save()
except:
    print "warning: Create emitter factory failed."    
    
#Create Event Group
print "Creating EventProfile"  
try:
    # Get EventProfile Group id
    optList = "/EventInfrastructureProvider:EventInfrastructureProvider/EventGroupProfileList:Event groups list/"
    print "optList="+ str(optList)
    egpl = AdminConfig.getid(optList)
    print "egpl="+str(egpl)
    
    # Create the EventGroupProfile
    eventGroupName = "Action Manager Group Profile"
    eventSelectorString = "CommonBaseEvent[extendedDataElements/@name = 'BusinessSituationName']"
    optList = [["eventGroupName",aamEventGroupName], ["eventSelectorString",aamEventSelectorString]]
    print "optList="+str(optList)
    epg = AdminConfig.create("EventGroupProfile",egpl,optList)
    print "epg="+str(epg)
    
    # Create the DistributionQueue
    optList = [["queueConnectionFactoryJNDIName",aamQConnFactoryJndi], ["queueJNDIName",aamQJndi]]
    print "optList=" + str(optList)
    dq = AdminConfig.create("DistributionQueue",epg,optList)
    print "dq="+str(dq)
    AdminConfig.save()
except:
    print "warning: failed to create EventProfile."    
print "done Creating EventProfile"
    



    