#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2008, 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import sys
import java

def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

# get line separator 
lineSeparator = java.lang.System.getProperty('line.separator') 

class Scope:
    CLUSTER_SCOPE = 1
    CELL_SCOPE = 2
    NODE_SCOPE = 3
    SERVER_SCOPE = 4
# instance variables are...
#    cell
#    node
#    server
#    cluster
    
    def __init__(self, cluster, cell, node, server):
        self.cluster = cluster
        self.cell = cell
        self.node = node
        self.server = server
        self.containmentPathMap = {}
        self.containmentPathMap[Scope.CLUSTER_SCOPE] = "/Cell:" + cell + "/Cluster:" + cluster + "/"
        self.containmentPathMap[Scope.CELL_SCOPE] = "/Cell:" + cell + "/"
        self.containmentPathMap[Scope.NODE_SCOPE] = "/Cell:" + cell + "/Node:" + node + "/"
        self.containmentPathMap[Scope.SERVER_SCOPE] = "/Cell:" + cell + "/Node:" + node + "/Server:" + server + "/"

    def getConfigId(self, scopeLevel):
        return AdminConfig.getid(self.getContainmentPath(scopeLevel))

    def getContainmentPath(self, scopeLevel):
        return self.containmentPathMap[scopeLevel]

#--------------------------------------------------------------------
# Delete Data Services Scheduler
#--------------------------------------------------------------------

scopeString = sys.argv[0]

dssName=sys.argv[1]
profilePath = sys.argv[2]

print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

print "Data Services Scheduler: " + dssName
scope = Scope("clusterName", cellName, nodeName, serverName)

scopeContainmentPath =""
if(scopeString =="CELL"):
    scopeContainmentPath = scope.getContainmentPath(Scope.CELL_SCOPE)
elif(scopeString =="NODE"):
    scopeContainmentPath = scope.getContainmentPath(Scope.NODE_SCOPE)
elif(scopeString =="SERVER"):
    scopeContainmentPath = scope.getContainmentPath(Scope.SERVER_SCOPE)
    
scopeId = AdminConfig.getid(scopeContainmentPath)
print "scopeId=" + scopeId
if (len(scopeId) == 0):
    raise RuntimeError, "The ID for "+scopeContainmentPath+" could not be found."

for schedulerInfoEntry in wsadminToList(AdminConfig.list("SchedulerConfiguration", scopeId )):
    schedulerNameOfEntry = AdminConfig.showAttribute(schedulerInfoEntry, "name" )
    print "schedulerNameOfEntry="+schedulerNameOfEntry
    if (cmp(schedulerNameOfEntry, dssName) == 0):
        print "The "+dssName+" scheduler exists. Deleting..."
        AdminConfig.remove(schedulerInfoEntry )
        AdminConfig.save( )
    #endIf 
#endFor 
