#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009, 2012. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java
import time
from com.ibm.wbimonitor.lifecycle.spi.mbeans import LifecycleServicesMBeanFactory
from com.ibm.wbimonitor.lifecycle.spi.beans  import LifecycleResultsBean
from com.ibm.wbimonitor.lifecycle.spi.beans  import LifecycleStepBean
from com.ibm.wbimonitor.lifecycle.spi.beans  import LifecycleVersionBean
from com.ibm.wbimonitor.persistence.metamodel.spi import StepStatus


def checkIfCubesDeployed():
	cubesDeployed = "false"
	try:
		serviceMBean = LifecycleServicesMBeanFactory.getMBean( AdminControl.getAdminClient() )
		print serviceMBean

		modelID = "Global_Process_Monitor"
		ts = 20111014060300L
		modelVersion = serviceMBean.listVersion( modelID,ts)
		print modelVersion

		createCognosCubeStep = LifecycleVersionBean.getStep(modelVersion,'createCognosCubes')
		print createCognosCubeStep

		createCognosCubeStatus = LifecycleStepBean.getStatus(createCognosCubeStep)
		print createCognosCubeStatus
		if ( createCognosCubeStatus == StepStatus.COMPLETE ):
			cubesDeployed = "true"
	except:
		cubesDeployed = "false"
	print "cubesDeployed =",cubesDeployed
	return cubesDeployed
#endDef

if ((len(sys.argv) != 1)):
    print "This script requires 1 parameter: profilePath"
    print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
    raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

# Define a JVM custom property.
if (ndType == "managed"):
    try:
        cellName = AdminControl.getCell()
    except:
        print "warning: AdminControl may not be available."
                
location = washome+"/installableApps.wbm/monitorModels"
print "location="+location

ear = globalProcessTaskEarName
app = globalProcessTaskAppname
basicSpaceFilename = globalProcessBasicSpaceFilename
advancedSpaceFilename = globalProcessAdvancedSpaceFilename
cell     = cellName
node     = nodeName
server   = serverName
        
rc = 0        
# Install EAR.
if(configureGlobalProcessTask == "true"):
    execfile(moncommonPath+'/installEar.py')
    rc2 = installEar(location, ear, app, node, server)
    if(rc2 == -1):
        rc = -1
        
if(rc == -1):
    raise ValueError("Install GlobalProcess Applications failed")
rc = 0        

# Install basic space.
if(configureGlobalProcessTask == "true"):
	if(configureBSpace == "true"):
		basicSpaceZipFile = washome+"/installableApps.wbm/monitorModels/BusinessSpace/"+basicSpaceFilename
		optList=["-serverName",server,"-nodeName",node,"-spaces",basicSpaceZipFile]
		AdminTask.updateBusinessSpaceWidgets(optList)
		AdminConfig.save()

# Install advanced space.
if(configureGlobalProcessTask == "true"):
	if(configureBSpace == "true"):
		basicSpaceZipFile = washome+"/installableApps.wbm/monitorModels/BusinessSpace/"+advancedSpaceFilename
		optList=["-serverName",server,"-nodeName",node,"-spaces",basicSpaceZipFile]
		AdminTask.updateBusinessSpaceWidgets(optList)
		AdminConfig.save()

i = 1

searchIntervalTime = 20
timeoutNumberOfIterations = 45

while i<=int(timeoutNumberOfIterations):
    cubesDeployed = checkIfCubesDeployed()
    if (cubesDeployed == "true"):
        break
    else:
        time.sleep(int(searchIntervalTime))
        i=i+1
if (cubesDeployed == "true"):
    print "Cognos cubes deployed"
else:
    print "Cognos cubes NOT deployed in the alotted time of", searchIntervalTime, "seconds for", timeoutNumberOfIterations, "cycles."
rc = 0        


