#  Licensed Materials - Property of IBM
#  5724-M23, 5724-M24
#  Copyright IBM Corporation 2007, 2011. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

location = "."
ear = aamEarName
app = aamAppname
cell     = cellName
node     = nodeName
server   = serverName

print "app: "+app+" cell: "+cell+" node: "+node+"server: "+server
        
if (ndType != "dmgr"):
    #uninstall EAR
    execfile(moncommonPath+'/uninstallEar.py')
    uninstallEar(app)

lineSeparator = java.lang.System.getProperty('line.separator') 

print "Removing EventProfile."
try:
    # Get the EventGroupProfile
    resourceList = AdminConfig.list("EventGroupProfile")
    resources = resourceList.split(lineSeparator)
    for i in range(len(resources)):
        if(len(resources[i])>0): 
           name = AdminConfig.showAttribute(resources[i],"eventGroupName")
           print "name="+name
           if(name == aamEventGroupName):
               AdminConfig.remove(resources[i])
               AdminConfig.save() 
except:
    print "warning: failed to remove EventProfile."    
print "Done removing EventProfile."

execfile(moncommonPath+'/MonitorServerUtil.py')
UtilWsadminHolder.AdminConfig = AdminConfig
UtilWsadminHolder.AdminTask = AdminTask

scope = Scope(clusterName, cell, node, server)
print "scope="+str(scope)
cellConfigId = scope.getConfigId(Scope.CELL_SCOPE)
print "cellConfigId="+str(cellConfigId)
                                     
print "Removing AAMActivationSpec"
try:
    # Get the AAMActivationSpec
    resourceList = AdminTask.listSIBJMSActivationSpecs(cellConfigId)
    resources = resourceList.split(lineSeparator)
    for i in range(len(resources)):
        if(len(resources[i])>0): 
           name = AdminConfig.showAttribute(resources[i],"name")
           print "name="+name
           if(name == aamActivationSpecName):
               AdminTask.deleteSIBJMSActivationSpec(resources[i])
               AdminConfig.save() 
except:
    print "warning: failed to remove AAMActivationSpec."    
print "Done removing AAMActivationSpec"

print "Removing AAMQueue"
try:
    # Get the AAMQueue
    resourceList = AdminTask.listSIBJMSQueues(cellConfigId)
    resources = resourceList.split(lineSeparator)
    for i in range(len(resources)):
        if(len(resources[i])>0): 
           name = AdminConfig.showAttribute(resources[i],"name")
           print "name="+name
           if(name == aamQName):
               AdminTask.deleteSIBJMSQueue(resources[i])
               AdminConfig.save() 
except:
    print "warning: failed to remove AAMQueue."    
print "Done removing AAMQueue"

print "Removing AAMQueueConnFactory"
try:
    # Get the AAMQueueConnFactory
    resourceList = AdminTask.listSIBJMSConnectionFactories(cellConfigId,"-type Queue")
    resources = resourceList.split(lineSeparator)
    for i in range(len(resources)):
        if(len(resources[i])>0): 
           name = AdminConfig.showAttribute(resources[i],"name")
           print "name="+name
           if(name == aamQConnFactoryName):
               AdminTask.deleteSIBJMSConnectionFactory(resources[i])
               AdminConfig.save() 
except:
    print "warning: failed to remove AAMQueueConnFactory."    
print "Done removing AAMQueueConnFactory"
