#************************************************************************
# Licensed Materials - Property of IBM
# 5724-M24
# Copyright IBM Corporation 2008, 2011.  All rights reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************

import java
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')
execfile(moncommonPath+'/MonitorServerUtil.py')

##################################################################
# Install the Monitor MSS EAR file and map a security role
##################################################################
location = washome+"/installableApps.wbm"
eartoinstall = location+"/"+mssServiceEarName+".ear"

# For each install task, the fields must be passed in the correct order.

# The MapRolesToUsers task consists of the following 5 fields:
#   "Role", "Everyone?", "All authenticated?",
#   "Mapped users", "Mapped groups".
role = 'deployer'
everyone = "AppDeploymentOption.No"
allAuthenticated = "AppDeploymentOption.Yes"
mappedUsers = ""
mappedGroups = ""
roleTaskInfo = [ role, everyone, allAuthenticated ]

for appName in wsadminToList(AdminApp.list( )):
        if (cmp(appName, "IBM_WBM_MSS_SERVICE") == 0):
                AdminApp.uninstall(appName )
                AdminConfig.save( )
                print "Uninstalled "+appName

# Example of specifying values for 1 install task
AdminApp.install(eartoinstall, ['-server', serverName, "-node", nodeName, '-MapRolesToUsers', [roleTaskInfo]] ) 
############################################################################
# Set the WAR class loader policy to "Single class loader for application"
# Other possible value is MULTIPLE
############################################################################

deployment = AdminConfig.getid("/Deployment:"+mssServiceAppname+"/" )
deployedObject = AdminConfig.showAttribute(deployment, "deployedObject")

warLoader = AdminConfig.showAttribute(deployedObject, "warClassLoaderPolicy")
print "\n current warClassLoaderPolicy=" + warLoader

AdminConfig.modify(deployedObject, [['warClassLoaderPolicy', 'SINGLE']])

warLoader2 = AdminConfig.showAttribute(deployedObject, "warClassLoaderPolicy")
print " new warClassLoaderPolicy=" + warLoader2

############################################################################
# Set the app class loader order to "Classes loaded with 
# application class loader first" (PARENT_LAST)
# Other possible value is PARENT_FIRST
############################################################################

classldr = AdminConfig.showAttribute(deployedObject, 'classloader')
mode = AdminConfig.showAttribute(classldr, 'mode')
print "\n current Class Loader mode=" + mode

AdminConfig.modify(classldr, [['mode', 'PARENT_LAST']])

mode2 = AdminConfig.showAttribute(classldr, 'mode')
print " new Class Loader mode=" + mode2

############################################################################
# Save the app
############################################################################
AdminConfig.save()
