# Licensed Materials - Property of IBM
# 5724-M24
# Copyright IBM Corporation 2007,2009. All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

# The wsadmin_classpath needs to be set to include com.ibm.wbimonitor.lifecycle.spi.jar
# sample command will be  <profile_home/bin>wsadmin -port <SOAP_PORT> -user adminUser1 -password admin_pw -lang jython 
# -wsadmin_classpath=<WAS_INSTALL>\plugins\com.ibm.wbimonitor.lifecycle.spi.jar -f createSuperUser.py userId
# The userid and password won't be needed if WAS security is turned off.
# The RESTSecurityAdminMBean is described in the documentation as well as in  com.ibm.wbimonitor.lifecycle.mbeans.
# WAS_INSTALL/plugins/com.ibm.wbimonitor.lifecycle.jar contains RESTSecurityAdminMBean.xml

from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System

from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

if ((len(sys.argv) != 1)):
    print "This script requires 1 parameter: userId"
    print "e.g.: <scriptname>.py wbmonitor"
    raise ValueError    

userId = sys.argv[0]

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The following assigns 'SuperUser' role to the user someUser. Fully qualified DN is required.
#The return type is a boolean 'true' or 'false'
result = rest_mbean.assignSuperUserRole("uid="+userId+",o=defaultWIMFileBasedRealm")
print result


