#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009, 2010. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.

import java 

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

if (ndType == "managed"):
    try:
        cellName = AdminControl.getCell()
    except:
        print "warning: AdminControl may not be available."    

busName = "MONITOR."+cellName+".Bus"
execfile(moncommonPath+'/MonitorServerUtil.py')
UtilWsadminHolder.AdminConfig = AdminConfig
UtilWsadminHolder.AdminTask = AdminTask
busInfo = BusInfo(busName, busDesc, busAliasName)
if (not doesBusExist(busInfo.name)):
    createBus(busInfo)
        
    # add the bus member
    try:
        print "\nAdding the SIBusMember with the following arguments"
    
        optList = ["-bus",busName]
        optList.append("-node")
        optList.append(nodeName)
        optList.append("-server")
        optList.append(serverName)
        
        if (msFileStore == "true"):
            optList.append("-fileStore")
            if (meLogDirectory != ""):
                optList.append("-logDirectory")
                optList.append(meLogDirectory)
            if (mePermanentStoreDirectory != ""):
                optList.append("-permanentStoreDirectory")
                optList.append(mePermanentStoreDirectory)
            if (meTemporaryStoreDirectory != ""):
                optList.append("-temporaryStoreDirectory")
                optList.append(meTemporaryStoreDirectory)
        elif(msDataStore == "true"):
            optList.append("-dataStore")
                
            lJnidiName = meDatasourceJndi;
            lSchemaName = dataStoreDefaultCEISchemaName
            lAuthAlias = datasourceAuthAliasName
            lCreateTable = "true"
            if (dataStoreExistingDataSource == "true"):
                lJnidiName = dataStoreJndiName
                lSchemaName = dataStoreSchemaName
                if(dataStoreAuthAlias != "(none)" and dataStoreAuthAlias != "${dataStoreAuthAlias}"):
                    lAuthAlias = dataStoreAuthAlias
                lCreateTable = dataStoreCreateTables
                
            if(dataStoreExistingDataSource != "true" and wbmDBType == S_COMMON_DB_DERBY_EMBEDDED):
                optList.append("-createDefaultDatasource")
                optList.append("true")
            else:
                optList.append("-createDefaultDatasource")
                optList.append("false")
                optList.append("-datasourceJndiName")
                optList.append(lJnidiName)
                optList.append("-schemaName")
                optList.append(lSchemaName)
                optList.append("-authAlias")
                optList.append(lAuthAlias)

                optList.append("-createTables")
                #The ME cannot create tables on zOS. The user has to run ddl manually.
                if(wbmDBType == S_COMMON_DB_DB2_ZOS or wbmDBType.startswith(S_COMMON_DB_DB2_ZOS)):
                    lCreateTable = "false"
                optList.append(lCreateTable)
    
        print "addSIBusMember optList="+str(optList) 
        AdminTask.addSIBusMember(optList)
        AdminConfig.save()
    
        print "Done adding the SIBusMember"
    except:
        print "warning: failed to add SIBusMember"
     
    
    try:   
        MonitorBusAuth = "MonitorBusAuth"
        busUserName = ""
        qualifiedMonitorBusAuth = ""
        aliasidlist = AdminConfig.list("JAASAuthData").splitlines()
    
        for aliasid in aliasidlist:
            qualifiedaliasName = AdminConfig.showAttribute(aliasid,"alias")
            i= qualifiedaliasName.find('/')
            name=qualifiedaliasName[i+1:len(qualifiedaliasName)]
            if (name==MonitorBusAuth):
                busUserName = AdminConfig.showAttribute(aliasid,"userId")
                qualifiedMonitorBusAuth = qualifiedaliasName
    
        print "busUserName="+busUserName
    
        print "\nConfiguring Security on the bus for "+MonitorBusAuth+" user "+busUserName
        securityArgs=["-bus",busName,"-user",busUserName]
        AdminTask.addUserToBusConnectorRole(securityArgs)
        AdminConfig.save()
        print "Done adding users and groups to bus connector roles"
    except:
        print "warning: failed to adding users and groups to bus connector. The user may already be created."    
    
    try:    
        destArgs=["-bus",busName,"-type","Queue","-name","ActionManagerQueueDestination","-node",nodeName,"-server",serverName]
        print "\nCreating the ActionManager destination with the following arguments"
        print destArgs
        AdminTask.createSIBDestination(destArgs)
        AdminConfig.save()
        print "Done creating the ActionManager destination"
    except:    
        print "warning: failed to create the ActionManager destination"