/* Licensed Materials - Property of IBM
   5655-FLW,5724-M24
   Copyright IBM Corporation 2007, 2011. All Rights Reserved.
   US Government Users Restricted Rights - Use, duplication or disclosure
   restricted by GSA ADP Schedule Contract with IBM Corp.
*/
WScript.StdOut.WriteLine(">> starting profileShortCut2StartMenuABXWBMServer.js");

var wshShell = WScript.createobject("WScript.Shell");
var fileObject = WScript.createobject("Scripting.FileSystemObject");

var startMenuLocation = wshShell.SpecialFolders("Programs");
WScript.StdOut.WriteLine("StartMenu Location = " + startMenuLocation);

var forReading = 1;
var tristateUseDefault = -2;
var txtFilePath = "${WASROOT}\\properties\\version\\install.wbm\\config\\install\\productShortCut2StartMenuWBM.txt";
WScript.StdOut.WriteLine("Getting start menu instance id at = " + txtFilePath);
var f = fileObject.GetFile(txtFilePath);
var ts = f.OpenAsTextStream(forReading, tristateUseDefault);
var icounter = ts.ReadLine();
ts.Close();

var scounter;
if (icounter == 0)
      scounter = "";
else
      scounter = " (" + icounter + ")";

// Get OS version. Ver 6 = Win Vista
var env = wshShell.Environment;
var osid = env("PROCESSOR_IDENTIFIER");
var osver = osid.charAt(osid.indexOf("Family") + 7);
WScript.StdOut.WriteLine("OS ID = " + osid + " ==> ver = " + osver);
      
// Get path to IE. Vista has different registry path
var cmd = "%windir%\\system32\\cmd.exe";
    
WScript.StdOut.WriteLine("cmd = " + cmd);

//Get the Win path
var winDir = env("WINDIR");
WScript.Echo(winDir);

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM");

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter)))
      fileObject.CreateFolder(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter);

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}");
            
if (!(fileObject.FolderExists(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}");

if (!(fileObject.FolderExists(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}\\${ABXPRODNAME}")))
      fileObject.CreateFolder(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}\\${ABXPRODNAME}");


var objShellLinkABXConsole = wshShell.CreateShortcut(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}\\${ABXPRODNAME}\\${ABXCONSOLE}.lnk");      
var objShellLinkABXAdmin = wshShell.CreateShortcut(startMenuLocation + "\\IBM\\Business Monitor 8.0" + scounter + "\\${PROFILES}\\${PROFILENAME}\\${ABXPRODNAME}\\${ABXADMIN}.url");

//1: Activates and displays a window. If the window is minimized or maximized, the system restores it to its original size and position. 
//3: Activates the window and displays it as a maximized window.  
//7: Minimizes the window and activates the next top-level window. 
objShellLinkABXConsole.WindowStyle = 1;

objShellLinkABXConsole.IconLocation = winDir+"\\system32\\telnet.exe";
objShellLinkABXConsole.TargetPath = winDir+"\\system32\\telnet.exe";
objShellLinkABXConsole.Arguments = "localhost ${ABXTELNETPORT}";
objShellLinkABXConsole.Save(); //commit change

objShellLinkABXAdmin.TargetPath = "http://localhost:${ABXPORT}/AlphabloxAdmin/home";
objShellLinkABXAdmin.Save(); //commit change


WScript.StdOut.WriteLine("<< ending profileShortCut2StartMenuABXWBMServer.js");
