@echo off
REM ***************************************************************
REM  Licensed Material - Property of IBM
REM 
REM  5724-M24 
REM 
REM  (c) Copyright IBM Corp. 2008.  All rights reserved.
REM 
REM  US Government Users Restricted Rights - Use, duplication or
REM  disclosure restricted by GSA ADP Schedule Contract with IBM
REM  Corp.
REM ***************************************************************
setlocal

@REM #######################################################
@REM #                                                     #
@REM # Read command line options                           #
@REM #                                                     #
@REM #######################################################

:Loop
IF "%1" == "" GOTO Continue
IF "%1" == "-f" (
  set dashboardFile=%2
  GOTO Forward
)
IF "%1" == "-h" (
  set hostName=%2
  GOTO Forward
)
IF "%1" == "-p" (
  set port=%2
  GOTO Forward
)
IF "%1" == "-u" (
  set userId=%2
  GOTO Forward
)
IF "%1" == "-s" (
  set password=%2
  GOTO Forward
)
IF "%1" == "-w" (
  set profileDir=%2
  GOTO Forward
)

:Forward
shift /1
shift /1
GOTO Loop
:Continue

call %profileDir%\bin\setupCmdLine.bat %*
set CURRENT_DIR=%cd%
set SCRIPT_DIR=%~dp0%
cd /d "%SCRIPT_DIR%"

set SYS_PROPS=-Djava.util.logging.config.file=logging.properties %*
set CLASS_HOME=.
set MY_CLASSPATH=%CLASS_HOME%;%CLASS_HOME%\bsimporter.jar;%CLASS_HOME%\commons-codec-1.3.jar;%CLASS_HOME%\commons-httpclient-3.1.jar;%CLASS_HOME%\commons-logging-1.1.1.jar

"%JAVA_HOME%"\bin\java -classpath %MY_CLASSPATH% com.ibm.wbmonitor.showcase.MyBSImporter %hostName% %port% %dashboardFile% %userId% %password%
if  "%ERRORLEVEL%" NEQ "0" goto fail

:success
	cd /d %CURRENT_DIR%
	endlocal
	exit /B 0
:fail
	@echo Business space importing failed.
	cd /d %CURRENT_DIR%
	endlocal
	exit /B 1
