#!/bin/sh

#############################################################################
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007,2008. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#############################################################################

#######################################################
#                                                     #
# Subroutine: Usage                                   #
#                                                     #
#######################################################

usage () {
  echo ""
  echo "importBSpace.sh -h <host name> -p <port> -f <dashboard file> -u <user ID> -s <password> -w <profile directory>"
  echo ""
  echo "where:  "
  echo ""
  echo "  -h <host name> :"
  echo "     Hostname of the server"
  echo ""
  echo "  -f <dashboard file> :"
  echo "     Dashboard data file to install"
  echo ""
  echo "  -p <port> :"
  echo "     http port number for the server"
  echo ""
  echo "  -s <password> :"
  echo "     password for the UserId"
  echo ""
  echo "  -u <user ID> :"
  echo "     User ID"
  echo ""
  echo "  -w <profile directory> :"
  echo "     WAS profile directory."
  echo ""
  exit
  
}

#######################################################
#                                                     #
# Variables                                           #
#                                                     #
#######################################################
runDir="."
runFile="NULL"
showcaseHome=""
testMode=5
modelDir="showcase"
profileDir=""
serverName="server1"
xmlFileName="NULL"
userId=""
password=""
tmpFile=showcase_$$
profileType=1
portChanged=0

#######################################################
#                                                     #
# Read command line options                           #
#                                                     #
#######################################################

while getopts ":h:f:p:s:u:w:" opt
do
  case $opt in
    h) hostname=$OPTARG;;
    f) datafile=$OPTARG;;
    p) port=$OPTARG;;
    s) password=$OPTARG;;
    u) userid=$OPTARG;;
    w) profileDir=$OPTARG;;
    ?) usage
  esac
done

. $profileDir/bin/setupCmdLine.sh 

SYS_PROPS=-Djava.util.logging.config.file=logging.properties
CLASS_HOME=${WAS_HOME}/scripts.wbm/BSImport
MY_CLASSPATH=$CLASS_HOME:$CLASS_HOME/bsimporter.jar:${CLASS_HOME}/commons-codec-1.3.jar:${CLASS_HOME}/commons-httpclient-3.1.jar:${CLASS_HOME}/commons-logging-1.1.1.jar
MY_CLASSPATH=${MY_CLASSPATH}:${CLASS_HOME}/commons-logging-adapters-1.1.1.jar:${CLASS_HOME}/commons-logging-api-1.1.1.jar
echo "MY_CLASSPATH = " $MY_CLASSPATH
${JAVA_HOME}/bin/java -classpath ${MY_CLASSPATH} com.ibm.wbmonitor.showcase.MyBSImporter $hostname $port $datafile $userid $password

