-- Licensed Materials - Property of IBM
-- 5724-M24
-- Copyright IBM Corporation 2010, 2011.  All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- ------------------------------------------------------------------------------------
--
-- Scriptfile to create schema (tables) for Oracle
--
---------------------------------------------------------------------------------------
-- Following variables need to be changed for customization before running this script: 
-- @SCHEMA@ = the schema owner, eg MONITOR
--
-- Run the script in SQL*Plus.
--
-- USAGE:  sqlplus system/passw0rd@orcl @createSampleTable_Oracle.sql
--
-- ------------------------------------------------------------------------------------

-------------------
-- Create tables --
-------------------
CREATE TABLE @SCHEMA@.FGS_SP_SECFILTER_MAPPED_T 
( 
	ID  NUMBER(20,0)  NOT NULL ,
	MODEL_ID VARCHAR2(128)  NOT NULL , 
	MC_ID VARCHAR2(128)  NOT NULL , 
	FILTER_METRIC_ID VARCHAR2(128)  NOT NULL , 
	EXTERNAL_FILTER_VALUE VARCHAR2(128)  NOT NULL , 
	ACTUAL_FILTER_VALUE VARCHAR2(128)  NOT NULL  , 
	PRIMARY KEY ( ID )
)
 LOGGING;
CREATE TABLE @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T  ( 
	ID  NUMBER(20,0)  NOT NULL ,
	MODEL_ID VARCHAR2(128)   NOT NULL , 
	MC_ID VARCHAR2(128)   NOT NULL , 
	SEC_OBJ_TYPE VARCHAR2(128)   NOT NULL , 
	EXTERNAL_OBJECT_ID VARCHAR2(128)   NOT NULL , 
	ACTUAL_OBJET_ID VARCHAR2(128)   NOT NULL  , 
	PRIMARY KEY ( ID )  
)
 LOGGING;
	
INSERT INTO @SCHEMA@.FGS_SP_SECFILTER_MAPPED_T (ID,MODEL_ID,MC_ID,FILTER_METRIC_ID,EXTERNAL_FILTER_VALUE,ACTUAL_FILTER_VALUE) values (1,'MortgageLendingBAM','Mortgage_Lending_BAM_MC','Loan_Officer','GeraldMander@mail.com','Gerald Mander');
INSERT INTO @SCHEMA@.FGS_SP_SECFILTER_MAPPED_T (ID,MODEL_ID,MC_ID,FILTER_METRIC_ID,EXTERNAL_FILTER_VALUE,ACTUAL_FILTER_VALUE) values (2,'MortgageLendingBAM','Mortgage_Lending_BAM_MC','Loan_Officer','RobertGump@mail.com','Robert Gump');
INSERT INTO @SCHEMA@.FGS_SP_SECFILTER_MAPPED_T (ID,MODEL_ID,MC_ID,FILTER_METRIC_ID,EXTERNAL_FILTER_VALUE,ACTUAL_FILTER_VALUE) values (3,'MortgageLendingBAM','Mortgage_Lending_BAM_MC','Loan_Officer','JoanSmith@mail.com','Joan Smith');

INSERT INTO @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T (ID,MODEL_ID,MC_ID,SEC_OBJ_TYPE,EXTERNAL_OBJECT_ID,ACTUAL_OBJET_ID) values (1,'MortgageLendingBAM',' ','KPI','Manager','Yearly_Maximum_Completed_Loan_Amount');
INSERT INTO @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T (ID,MODEL_ID,MC_ID,SEC_OBJ_TYPE,EXTERNAL_OBJECT_ID,ACTUAL_OBJET_ID) values (2,'MortgageLendingBAM',' ','KPI','Manager','Monthly_Maximum_Completed_Loan_Amount');
INSERT INTO @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T (ID,MODEL_ID,MC_ID,SEC_OBJ_TYPE,EXTERNAL_OBJECT_ID,ACTUAL_OBJET_ID) values (3,'MortgageLendingBAM',' ','KPI','Manager','Total_Completed_Loans');

INSERT INTO @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T (ID,MODEL_ID,MC_ID,SEC_OBJ_TYPE,EXTERNAL_OBJECT_ID,ACTUAL_OBJET_ID) values (4,'MortgageLendingBAM','Mortgage_Lending_BAM_MC','Metric','Manager','Application_Loan_Amount');
INSERT INTO @SCHEMA@.FGS_SP_OBJSEC_MAPPED_T (ID,MODEL_ID,MC_ID,SEC_OBJ_TYPE,EXTERNAL_OBJECT_ID,ACTUAL_OBJET_ID) values (5,'MortgageLendingBAM','Mortgage_Lending_BAM_MC','Metric','Manager','Completed_Loan_Amount');

COMMIT;

QUIT