#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007, 2008. All Rights Reserved.
#  US Government Users Restricted Rights- Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
import sys, os
from java.lang import String, System
from org.xml.sax import XMLReader
from org.xml.sax.helpers import XMLReaderFactory
#from xml.sax.saxutils import XMLGenerator

from wbmxml  import WBMXMLFilter,WBMXMLGenerator
from com.ibm.wbmonitor.install.common.log import ILogger
from util.wbmlogger import WBMLogger
from uninstallutils import moveFile

CN = "NIFStack"
MN = "main"

def cleanNIFStack(wasHome):
  global CN
  MN = "cleanNIFStack"
  log = WBMLogger.log

  nifStack = os.path.join(wasHome,  "properties")
  nifStack = os.path.join(nifStack, "version")
  nifStack = os.path.join(nifStack, "nif")
  nifStack = os.path.join(nifStack, "backup")
  nifStack = os.path.join(nifStack, "NIFStack.xml")

  log.msg(ILogger.TYPE_INFO, CN, MN, "Delete monitor entries in " + nifStack)
  print ""
  print "Delete monitor entries in " + nifStack

  tmpNIFStack = os.path.join(System.getProperty("java.io.tmpdir"), "NIFStack.xml")
  output = open(tmpNIFStack, "w")
  downstreamHandler = WBMXMLGenerator(output, "UTF-8")
  xmlReader = XMLReaderFactory.createXMLReader()
  filterHandler = UpdateNIFStack(xmlReader, downstreamHandler, log)
  filterHandler.parse(nifStack)
  output.close()

  #cp tmpNIFStack to nifStack
  moveFile(tmpNIFStack, nifStack)



#Define constants for the two states we care about
ALLOW_CONTENT = 1
SUPPRESS_CONTENT = 2

class UpdateNIFStack(WBMXMLFilter):
    def __init__(self, upstream, downstream, log):
        WBMXMLFilter.__init__(self,upstream,downstream)
	self._elements = ["maintenance"]
	self._log = log
        return

    def startElement(self, uri, name, qName, attrs):
        #Check if name is "profile"
        if self._state == ALLOW_CONTENT:
	  if (name == "maintenance"):
	    nameAttr       = attrs.getValue(uri,'name')
	    if (nameAttr.find("wbm.") == 0):
              self._state = SUPPRESS_CONTENT

        self._state_stack.append(self._state)
        
        #Only forward the event if the state warrants it
        if self._state == ALLOW_CONTENT:
	  i = 0
          myAttrs = {}
          while (i < attrs.getLength()):
	    myAttrs[attrs.getLocalName(i)] = attrs.getValue(i)
	    i += 1

          self._downstream.startElement(name, myAttrs)
        return

if __name__ == "__main__":
  print "ProcessNIFStack Sample"
