#!/bin/sh
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007, 2008. All Rights Reserved.
#  US Government Users Restricted Rights- Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.


#
#

echo ""
echo "WebSphere Business Monitor 6.2 Clean-up Utility"

usage () {
  echo ""
  echo "cleanup.sh -w <WAS_HOME> -f -h"
  echo "where"
  echo "  -w <WAS_HOME>: full path of Monitor Install direcotry"
  echo "  -f force. Will not prompt for user selection"
  echo "  -h print this help."
  echo ""
  exit
  
}

wasHome=""
interactive=1

while getopts ":w:fh" opt
do
  case $opt in
    w) wasHome=$OPTARG;; 
    f) interactive=0;;
    h) usage;;
    ?) usage
  esac
done


WBM_CLEANUP_INTERACTIVE=$interactive
export WBM_CLEANUP_INTERACTIVE

if [ -z "$wasHome" ]; then
  curDir=`dirname ${0}`
  if [ $curDir =  . ]; then
      curDir=`pwd`
  fi

  cd $curDir/../..
  wasHome=`pwd`
  cd $curDir
fi

#cd ${wasHome}/scripts.wbm/cleanup

WAS_HOME=${wasHome}
export WAS_HOME
echo "WAS_HOME: $WAS_HOME"


JYTHON_CACHE=${wasHome}/optionalLibraries/jython/cachedir/packages/jython.pkc
CP=${wasHome}/optionalLibraries/jython/jython.jar:lib/wbminstall_log.jar
JAVA_HOME=${wasHome}/java
JYTHON_HOME=${wasHome}/optionalLibraries/jython

if [ ! -f $JYTHON_CACHE ]; then
  echo ""
  echo "Load Jython libraries. Please wait ..."
  ${JAVA_HOME}/bin/java  -Dpyton.home=${JYTHON_HOME} -classpath "$CP" \
  org.python.util.jython dummy.jy  >/dev/null  2>&1 
  echo "Done."
fi

${JAVA_HOME}/bin/java  -Dpyton.home=${JYTHON_HOME} -classpath "$CP" \
org.python.util.jython cleanup.jy  ${wasHome}
  
