// Licensed Materials - Property of IBM
// 5724-M24 Copyright IBM Corporation 2009. All Rights Reserved.
// US Government Users Restricted Rights- Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

/**
 * This static class manages a collection of WLayers and is designed for
 * internal tracking of WLayers.
 */

/**
 * Static Constructor
 */
if ( !self.WLayerManager )
{
    self.WLayerManager = new WLayerManagerImpl();
}
function WLayerManagerImpl()
{
    // private variables
    this.layers = new Object();

    // public methods
    this.addWLayer      = WLayerManager_addWLayer;
    this.removeWLayer   = WLayerManager_removeWLayer;
    this.getWLayerByID  = WLayerManger_getWLayerByID;
}

/**
 * Add WLayer
 *
 * @param wLayer The WLayer object to add
 *
 * @return The previous WLayer associated with wLayer's id, or null if none 
 */
function WLayerManager_addWLayer( wLayer )
{
    var oldLayer = null;

    if ( wLayer != null )
    {
        oldLayer = this.layers[ wLayer.getID() ];
        this.layers[ wLayer.getID() ] = wLayer;
    }
    return oldLayer;
}

/**
 * Remove WLayer
 *
 * @param wLayer The WLayer object to remove
 *
 * @return The removed WLayer associated with wLayer's id, or null if none 
 */
function WLayerManager_removeWLayer( wLayer )
{
    var oldLayer = null;

    if ( wLayer != null )
    {
        oldLayer = this.layers[ wLayer.getID() ];
        this.layers[ wLayer.getID() ] = null;
    }
    return oldLayer;
}

/**
 * Get WLayer by ID
 *
 * @param id The unique ID of a WLayer
 *
 * @return The WLayer associated with id, or null if none
 */
function WLayerManger_getWLayerByID( id )
{
    return this.layers[ id ];
}
