<%@tag display-name="msgbox"%>
<%@attribute name="messages" required="true" type="java.util.Collection"%>
<%@taglib uri="http://java.sun.com/portlet" prefix="portlet"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%-- define portlet JSP vars --%>
<portlet:defineObjects />

<%-- set the locale to match what the portlet thinks is the locale --%>
<fmt:setLocale value="${renderRequest.locale}"/>

<%-- set the resource bundle name and key prefix to use between within the fmt:bundle element --%>
<fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="TAG.MSGBOX.">

<%-- compute some handy urls --%>
<c:url var="errorMessageIconURL"   context="${renderRequest.contextPath}" value="/images/MsgError.gif"/>
<c:url var="infoMessageIconURL"    context="${renderRequest.contextPath}" value="/images/Information.gif"/>
<c:url var="warningMessageIconURL" context="${renderRequest.contextPath}" value="/images/MsgWarning.gif"/>

<!-- Luis was here --><c:if test="${empty messages}"><!-- messages was empty --></c:if>
<c:if test="${not empty messages}">
<div class="messages">
<p class="title"><fmt:message key="TITLE"/></p>
<c:forEach items="${messages}" var="message">
	<c:choose>
		<c:when test="${fn:startsWith(message,'CWMTW') and (fn:substring(message,9,10) eq 'E')}">
			<c:set var="messageClass" value="error"/>
			<c:set var="messageIconURL" value="${errorMessageIconURL}"/>
		</c:when>
		<c:when test="${fn:startsWith(message,'CWMTC') and (fn:substring(message,9,10) eq 'E')}">
			<c:set var="messageClass" value="error"/>
			<c:set var="messageIconURL" value="${errorMessageIconURL}"/>
		</c:when>
		<c:when test="${fn:startsWith(message,'CWMTW') and (fn:substring(message,9,10) eq 'W')}">
			<c:set var="messageClass" value="warning"/>
			<c:set var="messageIconURL" value="${warningMessageIconURL}"/>
		</c:when>
		<c:otherwise>
			<c:set var="messageClass" value="information"/>
			<c:set var="messageIconURL" value="${infoMessageIconURL}"/>
		</c:otherwise>
	</c:choose>
	<p class="${messageClass}"><img border="0" src="${messageIconURL}" width="16" height="16" />${message}</p>
</c:forEach>
</div>
</c:if>

</fmt:bundle>