<%-- 
  Licensed Materials - Property of IBM
  5724-M24
  Copyright IBM Corporation 2011.
  All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp. 
--%>

<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" session="false"%>

<%@taglib uri="http://java.sun.com/portlet" prefix="portlet"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags" prefix="wbm"%>

<%-- define portlet JSP vars --%>
<portlet:defineObjects />

<%-- set the locale to match what the portlet thinks is the locale --%>
<fmt:setLocale value="${renderRequest.locale}"/>

<%-- import help support javascript library --%>
<c:url var="helpJavaScriptURL" context="${renderRequest.contextPath}" value="/scripts/help.js"/>
<script language="JavaScript" src="${helpJavaScriptURL}"></script>

<%-- set the resource bundle name and key prefix to use between within the fmt:bundle element --%>
<fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="COG.CONFIG.">

<%-- attach the monitor specifc stylesheet --%>
<c:url var="monitorStyleSheetURL" context="${renderRequest.contextPath}" value="/theme/monitor-styles.css"/>
<link rel="stylesheet" href="${monitorStyleSheetURL}" type="text/css" />

<script type="text/javascript">
function setExtURI(){
	   //document.forms[0].action= "setExtURI";
	   document.getElementById("hiddeninput").value="setExtURI";
	   document.forms[0].submit(); 
}
function deployCognos(){
	   //document.forms[0].action= "deployCognos";
	   document.getElementById("hiddeninput").value="deployCognos";
	   document.forms[0].submit(); 
}
function ${ns}func_1(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var targetElement = (evt.target) ? (evt.target) : ((evt.srcElement) ? evt.srcElement : null);
	if(targetElement.nodeType == 3) targetElement = targetElement.parentNode;
}

</script>

<div class="monitor">

<%-- display info/warning/error messages --%>
<wbm:msgbox messages="${messages}"/>

<c:set var="topologyStatusURL"><portlet:actionURL><portlet:param name="action" value="forward"/><portlet:param name="pageName" value="topology-status"/></portlet:actionURL></c:set>
<p class="breadcrumb-trail">
<a href="${topologyStatusURL}"><fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="MON.CONFIG."><fmt:message key="PAGE.BREADCRUMB"/></fmt:bundle></a> &gt; 
<fmt:message key="PAGE.BREADCRUMB"/></p>
<p><fmt:message key="PAGE.INSTRUCTION"/></p>

<%-- compute rest api service status display --%>
<c:choose>
	<c:when test="${cognosStatus.deployed}">
		<c:choose>
			<c:when test="${empty cognosStatus.location.cluster}">
				<c:set var="cognosStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.SERVER">
						<fmt:param value="${cognosStatus.location.server}"/>
						<fmt:param value="${cognosStatus.location.node}"/>
					</fmt:message>
				</c:set>
			</c:when>
			<c:otherwise>
				<c:set var="cognosStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.CLUSTER">
						<fmt:param value="${cognosStatus.location.cluster}"/>
					</fmt:message>
				</c:set>
			</c:otherwise>
		</c:choose>
	</c:when>
	<c:otherwise>
	<!-- d691245 begin -->
		<c:choose>
			<c:when test="${isCognosRemote=='true'}">
				<c:set var="cognosStatusValue"><fmt:message key="FIELD.STATUS.EXTURI"/></c:set>
			</c:when>
			<c:otherwise>
				<c:set var="cognosStatusValue"><fmt:message key="FIELD.STATUS.NOT.DEPLOYED"/></c:set>
			</c:otherwise>
		</c:choose>
	<!-- d691245 end -->
		
	</c:otherwise>
</c:choose>

<div class="mainContent">

<div class="sectionContent">
<p class="config-section-title"><fmt:message key="MAIN.SECTION.TITLE"/></p>
<table>
	<tr>
		<td><label class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.STATUS.TOOLTIP'/>"><fmt:message key="FIELD.STATUS.LABEL"/></label></td>
	</tr>
	<tr>
		<td><textarea rows="2"  name="statusDisplay" title="${cognosStatusValue}" readonly="readonly" class="a11y-read-only">${cognosStatusValue}</textarea></td>
	</tr>
</table>
<c:if test="${not cognosStatus.deployed}">
<p><fmt:message key="FIELDSET.LABEL"/></p>

<c:set var="deployCognosActionURL"><portlet:actionURL><portlet:param name="action" value="deployCognos"/></portlet:actionURL></c:set>
<form  action="${deployCognosActionURL}"  method="post">

	<fieldset><legend><fmt:message key="FIELDSET.LEGEND"/></legend>
	<table cellpadding="3">
		<tr>
			<td><label for="targetServer" class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>"><fmt:message key="FIELD.TARGET.LABEL"/></label></td>
		</tr>
		<tr>
			<td><select name="targetServer" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>">
			    	<option value=""><fmt:message key="FIELD.TARGET.OPTION.NONE"/></option>
				    <c:forEach var="server" items="${servers}">
				    	<option value="${server.key}">${server.value}*</option>
					</c:forEach>
					<c:forEach var="server" items="${serversNotAvailable}">
				    	<option value="${server.key}" disabled="disabled">${server.value}</option>				    	
					</c:forEach>
			    </select>
			</td>
		</tr>
		<tr>
			<td>
				<label  for="dbName" title="<fmt:message key="FIELD.DBNAME.TOOLTIP"/>" onclick="updateHelpPortlet(event);">
						<fmt:message key="FIELD.DBNAME.LABEL"/>
					<br>
					<input id="dbName" type="text" name="dbName" value="${dbName}" class="textEntry" title="<fmt:message key="FIELD.DBNAME.TOOLTIP"/>"  size="60">
				</label>
			</td>
		</tr>
		<tr>
			<td>
				<table width="100%" cellpadding="3">
					<tr valign="top">
						<fmt:message key="FIELD.DBID.TOOLTIP" var="monuidTooltip"/>
						<td class="table-text"  scope="row" valign="top">
							<label  for="dbUid" title="${monuidTooltip}" onclick="updateHelpPortlet(event);">
									<fmt:message key="SECURITY.DBUSERNAME.LABEL"/>
								<br>
								<input id="dbUid" type="text" name="dbUid" value="${dbUid}"  class="textEntry" title="${monuidTooltip}"  size="40">
								
							</label>
						</td>	
						
						<td class="table-text"  scope="row" valign="top">
							<label  for="dbPwd" title="${monuidTooltip}" onclick="updateHelpPortlet(event);">
								<fmt:message key="SECURITY.DBPWD.LABEL"/>
							<br>	
									<input id="dbPwd" type="password" name="dbPwd" value="${dbPwd}"　class="textEntry" title="${monuidTooltip}"  size="40">
							</label>	
						</td>	
						
					</tr>
				</table>
			</td>
		</tr>
		<tr valign="top">
			<td>
				<table width="100%" cellpadding="3">
					<tr valign="top">
						<fmt:message key="FIELD.MONUSERID.TOOLTIP" var="monuidTooltip"/>
						<td class="table-text"  scope="row" valign="top">
							<label  for="cogUid4Local" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" onclick="updateHelpPortlet(event);">
									<fmt:message key="FIELD.COGADMIN.LABEL"/>
								<br>
								<input id="cogUid4Local" type="text" name="cogUid4Local" class="textEntry" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" size="40">
							</label>
						</td>	
						<td class="table-text"  scope="row" valign="top">
							<label  for="cogPwd4Local" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" onclick="updateHelpPortlet(event);">
								<fmt:message key="FIELD.COGPWD.LABEL"/>
							<br>	
									<input id="cogPwd4Local" type="password" name="cogPwd4Local" class="textEntry" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" size="40"">
							</label>	
						</td>	
					</tr>
				</table>
			</td>
		</tr>		
		<tr>
			<td>
				<input id="launch-topology-wizard-button"  class="nav-button" type="button" onclick="deployCognos();"  value="<fmt:message key='BUTTON.LABEL'/>" title="<fmt:message key='BUTTON.TOOLTIP.CREATE.NEW'/>" name="launch-topology-wizard-button-name">
				<input type="hidden" id="hiddeninput" name="hiddeninput" value="">
			</td>
		</tr>
	</table>
	</fieldset>
	<fieldset><legend><fmt:message key="FIELDSET.LEGENDUSEEXTURI"/></legend>
		<table cellpadding="3">
			<tr valign="top">
				<td><label for="targetServer" class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='SECURITY.FIELD.TARGET.TOOLTIP'/>">
				<!-- fmt:message key="SECURITY.FIELD.TARGET.LABEL"/--></label></td>
			</tr>
			<tr valign="top">
				<td>
					<label  for="extURI" title="<fmt:message key="FIELD.EXTURI.TOOLTIP"/>" onclick="updateHelpPortlet(event);">
							<fmt:message key="FIELD.EXTURI.LABEL"/>
						<br>
						<input id="extURI" type="text" value="${extURI}" name="extURI" class="textEntry" title="<fmt:message key="FIELD.EXTURI.TOOLTIP"/>" size="60">
					</label>
				</td>
			</tr>
			<tr valign="top">
				<td>
					<table width="100%" cellpadding="3">
						<tr valign="top">
							<fmt:message key="FIELD.MONUSERID.TOOLTIP" var="monuidTooltip"/>
							<td class="table-text"  scope="row" valign="top">
								<label  for="cogUid" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" onclick="updateHelpPortlet(event);">
										<fmt:message key="FIELD.COGADMIN.LABEL"/>
									<br>
									<input id="cogUid" type="text" value="${cogUid}" name="cogUid"   class="textEntry" title="<fmt:message key='FIELD.COGADMIN.TOOLTIP'/>" size="40">
								</label>
							</td>	
							<td class="table-text"  scope="row" valign="top">
								<label  for="cogPwd" title="<fmt:message key='FIELD.COGPWD.TOOLTIP'/>" onclick="updateHelpPortlet(event);">
									<fmt:message key="FIELD.COGPWD.LABEL"/>
								<br>	
										<input id="cogPwd" type="password" value="${cogPwd}" name="cogPwd"  class="textEntry" title="<fmt:message key='FIELD.COGPWD.TOOLTIP'/>" size="40"">
								</label>	
							</td>	
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td>
					<input id="launch-topology-wizard-button" class="nav-button" type="button" onclick="setExtURI();" value="<fmt:message key="FIELD.EXTURI.SETBUTTON"/>" title="<fmt:message key='BUTTON.TOOLTIP'/>" name="launch-topology-wizard-button-name">
				</td>
			</tr>
		</table>
	</fieldset>
</form>
</c:if>
</div>
</div>

<div class="sideContent">
	
	<div class="sectionContent">
	<p class="config-section-title"><fmt:message key="LINK.SECTION.APPLICATIONS"/></p>
	<ul style="padding-left: 10px">
		<li><a class="nav-link" href="/ibm/console/navigatorCmd.do?forwardName=ApplicationDeployment.content.main&WSC=true"><fmt:message key="LINK.APPLICATIONS"/></a></li>
	</ul>
	</div>
	
</div>

</div>
</fmt:bundle>