<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" session="false"%>
<%-- Licensed Materials - Property of IBM
  -- 5724-M24
  -- Copyright IBM Corporation 2008,2010. All Rights Reserved.
  -- US Government Users Restricted Rights - Use, duplication
  -- or disclosure restricted by GSA ADP Schedule Contract
  -- with IBM Corp.
  --%>
<%@taglib uri="http://java.sun.com/portlet" prefix="portlet"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags" prefix="wbm"%>

<%-- define portlet JSP vars --%>
<portlet:defineObjects />

<%-- set the locale to match what the portlet thinks is the locale --%>
<fmt:setLocale value="${renderRequest.locale}"/>

<%-- import help support javascript library --%>
<c:url var="helpJavaScriptURL" context="${renderRequest.contextPath}" value="/scripts/help.js"/>
<script language="JavaScript" src="${helpJavaScriptURL}"></script>

<%-- set the resource bundle name and key prefix to use between within the fmt:bundle element --%>
<fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="DSS.CONFIG.">

<%-- attach the monitor specifc stylesheet --%>
<c:url var="monitorStyleSheetURL" context="${renderRequest.contextPath}" value="/theme/monitor-styles.css"/>
<link rel="stylesheet" href="${monitorStyleSheetURL}" type="text/css" />

<div class="monitor">

<%-- display info/warning/error messages --%>
<wbm:msgbox messages="${messages}"/>

<c:set var="topologyStatusURL"><portlet:actionURL><portlet:param name="action" value="forward"/><portlet:param name="pageName" value="topology-status"/></portlet:actionURL></c:set>
<p class="breadcrumb-trail">
<a href="${topologyStatusURL}"><fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="MON.CONFIG."><fmt:message key="PAGE.BREADCRUMB"/></fmt:bundle></a> &gt; 
<fmt:message key="PAGE.BREADCRUMB"/></p>
<p><fmt:message key="PAGE.INSTRUCTION"/></p>

<%-- compute rest api service status display --%>
<c:choose>
	<c:when test="${dataServicesSchedulerStatus.deployed}">
		<c:choose>
			<c:when test="${empty dataServicesSchedulerStatus.location.cluster}">
				<c:set var="dataServicesSchedulerStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.SERVER">
						<fmt:param value="${dataServicesSchedulerStatus.location.server}"/>
						<fmt:param value="${dataServicesSchedulerStatus.location.node}"/>
					</fmt:message>
				</c:set>
			</c:when>
			<c:otherwise>
				<c:set var="dataServicesSchedulerStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.CLUSTER">
						<fmt:param value="${dataServicesSchedulerStatus.location.cluster}"/>
					</fmt:message>
				</c:set>
			</c:otherwise>
		</c:choose>
	</c:when>
	<c:otherwise>
		<c:set var="dataServicesSchedulerStatusValue"><fmt:message key="FIELD.STATUS.NOT.DEPLOYED"/></c:set>
	</c:otherwise>
</c:choose>

<div class="mainContent">

<div class="sectionContent">
<p class="config-section-title"><fmt:message key="MAIN.SECTION.TITLE"/></p>
<table>
	<tr>
		<td><label class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.STATUS.TOOLTIP'/>"><fmt:message key="FIELD.STATUS.LABEL"/></label></td>
	</tr>
	<tr>
		<td><textarea rows="2" cols="40" name="statusDisplay" title="${dataServicesSchedulerStatusValue}" readonly="readonly" class="read-only">${dataServicesSchedulerStatusValue}</textarea>
	</tr>
</table>
<c:if test="${not dataServicesSchedulerStatus.deployed}">
<p><fmt:message key="FIELDSET.LABEL"/></p>
<fieldset><legend><fmt:message key="FIELDSET.LEGEND"/></legend>
<c:set var="deployDataServicesSchedulerActionURL"><portlet:actionURL><portlet:param name="action" value="deployDataServicesScheduler"/></portlet:actionURL></c:set>
<form action="${deployDataServicesSchedulerActionURL}" method="post">
	<table cellpadding="3">
		<tr>
			<td><label for="targetServer" class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>"><fmt:message key="FIELD.TARGET.LABEL"/></label></td>
		</tr>
		<tr>
			<td><select name="targetServer" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>">
			    	<option value=""><fmt:message key="FIELD.TARGET.OPTION.NONE"/></option>
				    <c:forEach var="server" items="${servers}">
				    	<option value="${server.key}">${server.value}</option>
					</c:forEach>
			    </select>
		</tr>
		<tr>
			<td><input id="launch-topology-wizard-button" class="nav-button" type="submit" value="<fmt:message key='BUTTON.LABEL'/>" title="<fmt:message key='BUTTON.TOOLTIP'/>" name="launch-topology-wizard-button-name"></td>
		</tr>
	</table>
</form>
</fieldset>
</c:if>
</div>
</div>

<div class="sideContent">
	
	<div class="sectionContent">
	<p class="config-section-title"><fmt:message key="LINK.SECTION.APPLICATIONS"/></p>
	<ul style="padding-left: 10px">
		<li><a class="nav-link" href="/ibm/console/navigatorCmd.do?forwardName=ApplicationDeployment.content.main&WSC=true"><fmt:message key="LINK.APPLICATIONS"/></a></li>
	</ul>
	</div>
	
</div>

</div>
</fmt:bundle>