#  Licensed Materials - Property of IBM
#  5724-M23, 5724-M24
#  Copyright IBM Corporation 2007, 2011. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java
import os
import time
from java.lang import System

#################################################
#                                               #
# Global variables                              #
#                                               #
#################################################
global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd

print "INFO: enter cognosProfileUpgrade.py"

if ((len(sys.argv) != 4)):
	print "This script (cognosProfileUpgrade.py) requires 4 parameter: traceString <TRACE_STRING> <PROFILE_PATH> <WAS_COGNOS_PATH>"
	print "e.g.: cognosProfileUpgrade.py -traceString com.ibm.wsspi.management.metadata.*=all C:/WBMon01 C:/Program Files (x86)/IBM/WID7_WTE/runtimes/bi_v7/AppServer/cognos"
	raise ValueError	

cognosRootPath = sys.argv[2]+'/cognos'

wasCognosRootPath = sys.argv[3]

def defineWinProperties(myDirName):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd
 
	dirList=os.listdir(cognosRootPath)
	restoreRootProfileCognosDir=backupRootProfileCognosDir
	for fname in dirList:
		if (fname.find(myDirName+".original751.") != -1):
			restoreRootProfileCognosDir=os.path.normpath(cognosRootPath+'/'+fname)

	sourceProfileCognosDir = '"'+originalProfileCognosDir.replace('\\',os.sep)+'"'
	backupProfileCognosDir ='"'+os.path.basename(backupRootProfileCognosDir)+'"'
	renameCmd              = "rename " + sourceProfileCognosDir + " " + backupProfileCognosDir
	copyWASCognosCmd       = "xcopy /Y /S /I " + wasCognosRootPath + " " + sourceProfileCognosDir + " 1> NUL 2>&1"
	deleteServerCognosCmd = "rmdir /S /Q " + sourceProfileCognosDir + " 1> NUL 2>&1"

	originalCertDir        = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"+'"'
	originalCskDir         = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"+'"'
	originalEncryptDir     = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"+'"'
	originalSignDir        = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"+'"'
	originalLogsDir        = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"logs"+'"'
	originalMonitorFile    = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"+'"'
	originalCogstartupFile = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"+'"'
	originalSecureFile     = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"+'"'

# Directories/Files that need to be deleted after the WAS/cognos directory is copied to <PROFILE_HOME>/cognos/<SERVER>
	sourceCgiBinDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"cgi-bin"
	sourceBinJreDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"bin"+os.sep+"jre"
	sourceBinUtilDir     = wasCognosRootPath.replace('\\',os.sep)+os.sep+"bin"+os.sep+"utilities"
	sourceInstLogDir     = wasCognosRootPath.replace('\\',os.sep)+os.sep+"instlog"
	sourceMapsDir        = wasCognosRootPath.replace('\\',os.sep)+os.sep+"maps"
	sourceTempDir        = wasCognosRootPath.replace('\\',os.sep)+os.sep+"temp"
	sourceWarDir         = wasCognosRootPath.replace('\\',os.sep)+os.sep+"war"
	sourceUninstDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"uninstall"
	sourceWebDocDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"webcontent"+os.sep+"documentation"
	sourceP2pdEarFile    = wasCognosRootPath.replace('\\',os.sep)+os.sep+"p2pd.ear"

	originalCgiBinDir      = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"cgi-bin"+'"'
	originalBinJreDir      = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"bin"+os.sep+"jre"+'"'
	originalBinUtilDir     = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"bin"+os.sep+"utilities"+'"'
	originalInstLogDir     = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"instlog"+'"'
	originalMapsDir        = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"maps"+'"'
	originalTempDir        = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"temp"+'"'
	originalWarDir         = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"war"+'"'
	originalUninstDir      = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"uninstall"+'"'
	originalWebDocDir      = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"webcontent"+os.sep+"documentation"+'"'
	originalP2pdEarFile    = '"'+originalProfileCognosDir.replace('\\',os.sep)+os.sep+"p2pd.ear"+'"'

	backupCertDir        = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"+'"'
	backupCskDir         = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"+'"'
	backupEncryptDir     = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"+'"'
	backupSignDir        = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"+'"'
	backupLogsDir        = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"logs"+'"'
	backupMonitorFile    = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"+'"'
	backupCogstartupFile = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"+'"'
	backupSecureFile     = '"'+backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"+'"'

	restoreCertDir        = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"+'"'
	restoreCskDir         = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"+'"'
	restoreEncryptDir     = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"+'"'
	restoreSignDir        = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"+'"'
	restoreMonitorFile    = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"+'"'
	restoreCogstartupFile = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"+'"'
	restoreSecureFile     = '"'+restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"+'"'

# Profile's ORIGINAL Cognos Directory
	print "  Profile/server directory:          "+originalProfileCognosDir
# Profile's BACKUP Destination directory
	print "  Server's Backup TO directory:      "+backupRootProfileCognosDir
	print "  Server's Restore FROM directory:   "+restoreRootProfileCognosDir
	print "  Parent's Restore FROM directory:   "+wasCognosRootPath

	mkBackupDirCmd      = "echo. 1> NUL 2>&1"
	backupCertsCmd      = "xcopy /Y /S /I " + originalCertDir        + " " + backupCertDir
	backupCskCmd        = "xcopy /Y /S /I " + originalCskDir         + " " + backupCskDir
	backupEncryptCmd    = "xcopy /Y /S /I " + originalEncryptDir     + " " + backupEncryptDir
	backupSignCmd       = "xcopy /Y /S /I " + originalSignDir        + " " + backupSignDir
	if os.path.exists( originalLogsDir.replace('"','')):
		backupLogsCmd       = "xcopy /Y /S /I " + originalLogsDir        + " " + backupLogsDir
	else:
		backupLogsCmd      = "echo. 1> NUL 2>&1"
	backupMonitorCmd    = "copy /Y "        + originalMonitorFile    + " " + backupMonitorFile
	backupCogstartupCmd = "copy /Y "        + originalCogstartupFile + " " + backupCogstartupFile
	backupSecurityCmd   = "copy /Y "        + originalSecureFile     + " " + backupSecureFile

# Directories/Files that need to be deleted after the WAS/cognos directory is copied to <PROFILE_HOME>/cognos/<SERVER>
	if os.path.exists( sourceBinJreDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceBinJreDir.replace('"','');
		deleteOriginalBinJreCmd      = "rmdir /S /Q " + originalBinJreDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceBinJreDir.replace('"','');
		deleteOriginalBinJreCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceBinUtilDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceBinUtilDir.replace('"','');
		deleteOriginalBinUtilCmd     = "rmdir /S /Q " + originalBinUtilDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceBinUtilDir.replace('"','');
		deleteOriginalBinUtilCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceCgiBinDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceCgiBinDir.replace('"','');
		deleteOriginalCgiBinCmd      = "rmdir /S /Q " + originalCgiBinDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceCgiBinDir.replace('"','');
		deleteOriginalCgiBinCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceInstLogDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceInstLogDir.replace('"','');
		deleteOriginalInstLogCmd     = "rmdir /S /Q " + originalInstLogDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceInstLogDir.replace('"','');
		deleteOriginalInstLogCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceMapsDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceMapsDir.replace('"','');
		deleteOriginalMapsCmd        = "rmdir /S /Q " + originalMapsDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceMapsDir.replace('"','');
		deleteOriginalMapsCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceTempDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceTempDir.replace('"','');
		deleteOriginalTempCmd        = "rmdir /S /Q " + originalTempDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceTempDir.replace('"','');
		deleteOriginalTempCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceUninstDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceUninstDir.replace('"','');
		deleteOriginalUninstCmd      = "rmdir /S /Q " + originalUninstDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceUninstDir.replace('"','');
		deleteOriginalUninstCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceWarDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceWarDir.replace('"','');
		deleteOriginalWarCmd         = "rmdir /S /Q " + originalWarDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceWarDir.replace('"','');
		deleteOriginalWarCmd      = "echo. 1> NUL 2>&1"

	if os.path.exists( sourceWebDocDir.replace('"','')):
		print "  DELETE DIR  Exists: "+sourceWebDocDir.replace('"','');
		deleteOriginalWebDocCmd      = "rmdir /S /Q " + originalWebDocDir + " 1> NUL 2>&1"
	else:
		print "  DELETE DIR  Does not exist: "+sourceWebDocDir.replace('"','');
		deleteOriginalWebDocCmd      = "echo. 1> NUL 2>&1"

	if os.path.isfile( sourceP2pdEarFile.replace('"','')):
		print "  DELETE FILE Exists: "+sourceP2pdEarFile.replace('"','');
		deleteOriginalP2pdEarCmd     = "del /Q " + originalP2pdEarFile + " 1> NUL 2>&1"
	else:
		print "  DELETE FILE Does not exist: "+sourceP2pdEarFile.replace('"','');
		deleteOriginalP2pdEarCmd      = "echo. 1> NUL 2>&1"

	restoreCertsCmd      = "xcopy /Y /S /I " + restoreCertDir        + " " + originalCertDir
	restoreCskCmd        = "xcopy /Y /S /I " + restoreCskDir         + " " + originalCskDir
	restoreEncryptCmd    = "xcopy /Y /S /I " + restoreEncryptDir     + " " + originalEncryptDir
	restoreSignCmd       = "xcopy /Y /S /I " + restoreSignDir        + " " + originalSignDir
	restoreMonitorCmd    = "copy /Y "        + restoreMonitorFile    + " " + originalMonitorFile
	restoreCogstartupCmd = "copy /Y "        + restoreCogstartupFile + " " + originalCogstartupFile
	restoreSecurityCmd   = "copy /Y "        + restoreSecureFile     + " " + originalSecureFile

def defineNonWinProperties(myDirName):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd

	dirList=os.listdir(cognosRootPath)
	restoreRootProfileCognosDir=backupRootProfileCognosDir
	for fname in dirList:
		#  The 'nnn' in the string '.originalnnn.' must be changed for each release that this script runs against
		if (fname.find(myDirName+".original751.") != -1):
			restoreRootProfileCognosDir=os.path.normpath(cognosRootPath+'/'+fname)
 
	sourceProfileCognosDir = originalProfileCognosDir.replace('\\',os.sep)
	backupProfileCognosDir = os.path.basename(backupRootProfileCognosDir)

	originalCertDir        = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"
	originalCskDir         = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"
	originalEncryptDir     = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"
	originalSignDir        = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"
	originalLogsDir        = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"logs"
	originalMonitorFile    = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"
	originalCogstartupFile = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"
	originalSecureFile     = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"

# Directories/Files that need to be deleted after the WAS/cognos directory is copied to <PROFILE_HOME>/cognos/<SERVER>
	sourceCgiBinDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"cgi-bin"
	sourceBinJreDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"bin"+os.sep+"jre"
	sourceBinUtilDir     = wasCognosRootPath.replace('\\',os.sep)+os.sep+"bin"+os.sep+"utilities"
	sourceInstLogDir     = wasCognosRootPath.replace('\\',os.sep)+os.sep+"instlog"
	sourceMapsDir        = wasCognosRootPath.replace('\\',os.sep)+os.sep+"maps"
	sourceTempDir        = wasCognosRootPath.replace('\\',os.sep)+os.sep+"temp"
	sourceWarDir         = wasCognosRootPath.replace('\\',os.sep)+os.sep+"war"
	sourceUninstDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"uninstall"
	sourceWebDocDir      = wasCognosRootPath.replace('\\',os.sep)+os.sep+"webcontent"+os.sep+"documentation"
	sourceP2pdEarFile    = wasCognosRootPath.replace('\\',os.sep)+os.sep+"p2pd.ear"

	originalCgiBinDir      = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"cgi-bin"
	originalBinJreDir      = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"bin"+os.sep+"jre"
	originalBinUtilDir     = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"bin"+os.sep+"utilities"
	originalInstLogDir     = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"instlog"
	originalMapsDir        = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"maps"
	originalTempDir        = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"temp"
	originalWarDir         = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"war"
	originalUninstDir      = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"uninstall"
	originalWebDocDir      = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"webcontent"+os.sep+"documentation"
	originalP2pdEarFile    = originalProfileCognosDir.replace('\\',os.sep)+os.sep+"p2pd.ear"

	backupCertDir        = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"
	backupCskDir         = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"
	backupEncryptDir     = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"
	backupSignDir        = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"
	backupLogsDir        = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"logs"
	backupMonitorFile    = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"
	backupCogstartupFile = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"
	backupSecureFile     = backupRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"

	restoreCertDir        = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"certs"
	restoreCskDir         = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"csk"
	restoreEncryptDir     = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"encryptkeypair"
	restoreSignDir        = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"signkeypair"
	restoreMonitorFile    = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"monitor.xml"
	restoreCogstartupFile = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"cogstartup.xml"
	restoreSecureFile     = restoreRootProfileCognosDir.replace('\\',os.sep)+os.sep+"configuration"+os.sep+"xqe.securecache.config.xml"

	renameCmd             = "mv "     + sourceProfileCognosDir + " " + backupProfileCognosDir + " >/dev/null"
	mkBackupDirCmd        = "mkdir -p " +  backupRootProfileCognosDir+os.sep+"configuration >/dev/null"

	copyWASCognosCmd      = "cp -RP " + wasCognosRootPath + " " + sourceProfileCognosDir + " >/dev/null"
	deleteServerCognosCmd = "rm -rf " + sourceProfileCognosDir + " >/dev/null"

# Profile's ORIGINAL Cognos Directory
	print "  Profile/server directory:          "+originalProfileCognosDir
# Profile's BACKUP Destination directory
	print "  Server's Backup TO directory:      "+backupRootProfileCognosDir
	print "  Server's Restore FROM directory:   "+restoreRootProfileCognosDir
	print "  Parent's Restore FROM directory:   "+wasCognosRootPath
	
	backupCertsCmd      = "cp -RPf " + originalCertDir        + " " + backupCertDir
	backupCskCmd        = "cp -RPf " + originalCskDir         + " " + backupCskDir
	backupEncryptCmd    = "cp -RPf " + originalEncryptDir     + " " + backupEncryptDir
	backupSignCmd       = "cp -RPf " + originalSignDir        + " " + backupSignDir
	if os.path.exists( originalLogsDir):
		backupLogsCmd       = "cp -RPf " + originalLogsDir        + " " + backupLogsDir
	else:
		backupLogsCmd      = "echo >/dev/null"
	backupMonitorCmd    = "cp -f "   + originalMonitorFile    + " " + backupMonitorFile
	backupCogstartupCmd = "cp -f "   + originalCogstartupFile + " " + backupCogstartupFile
	backupSecurityCmd   = "cp -f "   + originalSecureFile     + " " + backupSecureFile

# Directories/Files that need to be deleted after the WAS/cognos directory is copied to <PROFILE_HOME>/cognos/<SERVER>
	if os.path.exists( sourceBinJreDir):
		print "  DELETE DIR  Exists: "+sourceBinJreDir;
		deleteOriginalBinJreCmd      = "rm -rf " + originalBinJreDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceBinJreDir;
		deleteOriginalBinJreCmd      = "echo >/dev/null"

	if os.path.exists( sourceBinUtilDir):
		print "  DELETE DIR  Exists: "+sourceBinUtilDir;
		deleteOriginalBinUtilCmd     = "rm -rf " + originalBinUtilDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceBinUtilDir;
		deleteOriginalBinUtilCmd      = "echo >/dev/null"

	if os.path.exists( sourceCgiBinDir):
		print "  DELETE DIR  Exists: "+sourceCgiBinDir;
		deleteOriginalCgiBinCmd      = "rm -rf " + originalCgiBinDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceCgiBinDir;
		deleteOriginalCgiBinCmd      = "echo >/dev/null"

	if os.path.exists( sourceInstLogDir):
		print "  DELETE DIR  Exists: "+sourceInstLogDir;
		deleteOriginalInstLogCmd     = "rm -rf " + originalInstLogDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceInstLogDir;
		deleteOriginalInstLogCmd      = "echo >/dev/null"

	if os.path.exists( sourceMapsDir):
		print "  DELETE DIR  Exists: "+sourceMapsDir;
		deleteOriginalMapsCmd        = "rm -rf " + originalMapsDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceMapsDir;
		deleteOriginalMapsCmd      = "echo >/dev/null"

	if os.path.exists( sourceTempDir):
		print "  DELETE DIR  Exists: "+sourceTempDir;
		deleteOriginalTempCmd        = "rm -rf " + originalTempDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceTempDir;
		deleteOriginalTempCmd      = "echo >/dev/null"

	if os.path.exists( sourceUninstDir):
		print "  DELETE DIR  Exists: "+sourceUninstDir;
		deleteOriginalUninstCmd      = "rm -rf " + originalUninstDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceUninstDir;
		deleteOriginalUninstCmd      = "echo >/dev/null"

	if os.path.exists( sourceWarDir):
		print "  DELETE DIR  Exists: "+sourceWarDir;
		deleteOriginalWarCmd         = "rm -rf " + originalWarDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceWarDir;
		deleteOriginalWarCmd      = "echo >/dev/null"

	if os.path.exists( sourceWebDocDir):
		print "  DELETE DIR  Exists: "+sourceWebDocDir;
		deleteOriginalWebDocCmd      = "rm -rf " + originalWebDocDir + " >/dev/null"
	else:
		print "  DELETE DIR  Does not exist: "+sourceWebDocDir;
		deleteOriginalWebDocCmd      = "echo >/dev/null"

	if os.path.isfile( sourceP2pdEarFile):
		print "  DELETE FILE Exists: "+sourceP2pdEarFile;
		deleteOriginalP2pdEarCmd     = "rm -f " + originalP2pdEarFile + " >/dev/null"
	else:
		print "  DELETE FILE Does not exist: "+sourceP2pdEarFile;
		deleteOriginalP2pdEarCmd      = "echo >/dev/null"

	restoreCertsCmd      = "cp -RPf " + restoreRootProfileCognosDir + "/configuration/certs " + originalProfileCognosDir + "/configuration/certs >/dev/null"
	restoreCskCmd        = "cp -RPf " + restoreRootProfileCognosDir + "/configuration/csk "   + originalProfileCognosDir + "/configuration/csk >/dev/null"
	restoreEncryptCmd    = "cp -RPf " + restoreRootProfileCognosDir + "/configuration/encryptkeypair " + originalProfileCognosDir + "/configuration/encryptkeypair >/dev/null"
	restoreSignCmd       = "cp -RPf " + restoreRootProfileCognosDir + "/configuration/signkeypair " + originalProfileCognosDir + "/configuration/signkeypair >/dev/null"
	restoreMonitorCmd    = "cp -f "   + restoreRootProfileCognosDir + "/configuration/monitor.xml " + originalProfileCognosDir + "/configuration/monitor.xml >/dev/null"
	restoreCogstartupCmd = "cp -f "   + restoreRootProfileCognosDir + "/configuration/cogstartup.xml " + originalProfileCognosDir + "/configuration/cogstartup.xml >/dev/null"
	restoreSecurityCmd   = "cp -f "   + restoreRootProfileCognosDir + "/configuration/xqe.securecache.config.xml " + originalProfileCognosDir + "/configuration/xqe.securecache.config.xml >/dev/null"

def runBackupCommand(thisCommand):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd

	rc = 0
	print "\n  --------------- Backup Command ---------------"
	print "  COMMAND: ",thisCommand
	rc = os.system( thisCommand )
	if (rc == 0):
		print "  COMMAND SUCCESS.\n"
		return(rc)
	else:
		print "  FAILED.\n    COMMAND: ",thisCommand,"\n    RETURN CODE: ",rc,"\n    CLEAN UP ACTION REQUIRED:\n      This Cognos server instance directory is incomplete.\n      (1) Preserve any original configurations.\n      (2) Delete the ",backupRootProfileCognosDir,"\n      (3) Delete the ",originalProfileCognosDir,"\n        A new ",originalProfileCognosDir," will be created on the next server startup.\n\n"
		raise BackupError

def runRestoreCommand(thisCommand):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreDir, deleteOriginalBinUtilDir, deleteOriginalCgiBinDir, deleteOriginalCogstartupFile, deleteOriginalCskDir, deleteOriginalEncryptDir, deleteOriginalInstLogDir, deleteOriginalLogsCmd
	global deleteOriginalMapsDir, deleteOriginalMonitorFile, deleteOriginalP2pdEarFile, deleteOriginalSignDir, deleteOriginalTempDir, deleteOriginalUninstDir, deleteOriginalWarDir, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd

	rc = 0
	print "\n  --------------- Restore Command ---------------"
	print "  COMMAND: ",thisCommand
	rc = os.system( thisCommand )
	if (rc == 0):
		print "  COMMAND SUCCESS.\n"
		return(rc)
	else:
		print "  FAILED.\n    COMMAND: ",thisCommand,"\n    RETURN CODE: ",rc,"\n    NO CLEAN UP ACTION REQUIRED!\n\n"
		raise RestoreError

def runDeleteCommand(thisCommand):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreDir, deleteOriginalBinUtilDir, deleteOriginalCgiBinDir, deleteOriginalCogstartupFile, deleteOriginalCskDir, deleteOriginalEncryptDir, deleteOriginalInstLogDir, deleteOriginalLogsCmd
	global deleteOriginalMapsDir, deleteOriginalMonitorFile, deleteOriginalP2pdEarFile, deleteOriginalSignDir, deleteOriginalTempDir, deleteOriginalUninstDir, deleteOriginalWarDir, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd

	rc = 0
	print "\n  --------------- Delete Command ---------------"
	print "  COMMAND: ",thisCommand
	rc = os.system( thisCommand )
	if (rc == 0):
		print "  COMMAND SUCCESS.\n"
		return(rc)
	else:
		print "  FAILED.\n    COMMAND: ",thisCommand,"\n    RETURN CODE: ",rc,"\n    NO CLEAN UP ACTION REQUIRED!\n\n"
		raise DeleteError

def upgradeOneServer():
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd
 
#	print "    ------------------------------\n    os.system('"+renameCmd+"')"
#	os.system( renameCmd )

	rc = 0
	runningTotal = 0

	try:
		runningTotal =+ runBackupCommand( mkBackupDirCmd )
		runningTotal =+ runBackupCommand( backupCertsCmd )
		runningTotal =+ runBackupCommand( backupCskCmd )
		runningTotal =+ runBackupCommand( backupEncryptCmd )
		runningTotal =+ runBackupCommand( backupLogsCmd )
		runningTotal =+ runBackupCommand( backupSignCmd )
		runningTotal =+ runBackupCommand( backupMonitorCmd )
		runningTotal =+ runBackupCommand( backupCogstartupCmd )
		runningTotal =+ runBackupCommand( backupSecurityCmd )
	except BackupError:
		print "  Error during backup"
		sys.exit(runningTotal)

	print "\n  --------------- Delete Command ---------------"
	print "  COMMAND: ",deleteServerCognosCmd
	rc += os.system( deleteServerCognosCmd )
	if (rc == 0):
		print "  COMMAND SUCCESS.\n"
		runningTotal =+rc
	else:
		print "  FAILED.\n    COMMAND: ",deleteServerCognosCmd,"\n    RETURN CODE: ",rc,"\n    CLEAN UP ACTIONS REQUIRED:\n      (1) Delete the ",originalProfileCognosDir,"\n      (2) Copy ",restoreRootProfileCognosDir,"\n        to ",originalProfileCognosDir,"\n    (3) Repeat this upgrade step.\n\n"
		sys.exit(rc)

	print "\n  --------------- Copy Command ---------------"
	print "  COMMAND: ",copyWASCognosCmd
	rc += os.system( copyWASCognosCmd )
	if (rc == 0):
		print "  COMMAND SUCCESS.\n"
		runningTotal =+rc
	else:
		print "  FAILED.\n    COMMAND: ",copyWASCognosCmd,"\n    RETURN CODE: ",rc,"\n    CLEAN UP ACTIONS REQUIRED:\n      (1) Delete the ",originalProfileCognosDir,"\n      (2) Copy ",restoreRootProfileCognosDir,"\n          to ",originalProfileCognosDir,"      (3) Repeat this upgrade step.\n\n"
		sys.exit(rc)

	try:
		print "  Delete cmds"
		runDeleteCommand( deleteOriginalBinJreCmd )
		runDeleteCommand( deleteOriginalBinUtilCmd )
		runDeleteCommand( deleteOriginalCgiBinCmd )
		runDeleteCommand( deleteOriginalInstLogCmd )
		runDeleteCommand( deleteOriginalMapsCmd )
		runDeleteCommand( deleteOriginalUninstCmd )
		runDeleteCommand( deleteOriginalWarCmd )
		runDeleteCommand( deleteOriginalWebDocCmd )
		runDeleteCommand( deleteOriginalP2pdEarCmd )
	except DeleteError:
		print "  Error during delete"

	try:
		print "  Restore cmds"
		runningTotal =+ runRestoreCommand( restoreCertsCmd )
		runningTotal =+ runRestoreCommand( restoreCskCmd )
		runningTotal =+ runRestoreCommand( restoreEncryptCmd )
		runningTotal =+ runRestoreCommand( restoreSignCmd )
		runningTotal =+ runRestoreCommand( restoreMonitorCmd )
		runningTotal =+ runRestoreCommand( restoreCogstartupCmd )
		runningTotal =+ runRestoreCommand( restoreSecurityCmd )
	except RestoreError:
		print "  Error during restore"
		sys.exit(runningTotal)
	else:
		return(runningTotal)
	return(runningTotal)

def getBackupDirectoryType(myDirList, myFname):
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupLogsCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd
	for fname1 in myDirList:
		if (fname1.find(myFname+".original751.") != -1):
			print "\n  FOUND an original back up of the server directory.\n  Using '.backup751.' for the directory rename."
			return(".backup751.")
	return(".original751.")

def upgradeProfilesCognosServers():
	global copyWASCognosCmd, deleteServerCognosCmd, mkBackupDirCmd, renameCmd, wasCognosRootPath

	global backupCertDir, backupCogstartupFile, backupCskDir, backupLogsDir, backupMonitorFile, backupProfileCognosDir, backupRootProfileCognosDir, backupSignDir

	global backupCertsCmd, backupCogstartupCmd, backupCskCmd, backupEncryptCmd, backupMonitorCmd, backupSecurityCmd, backupSignCmd

	global deleteOriginalBinJreCmd, deleteOriginalBinUtilCmd, deleteOriginalCgiBinCmd, deleteOriginalCogstartupCmd, deleteOriginalCskCmd, deleteOriginalEncryptCmd, deleteOriginalInstLogCmd, deleteOriginalLogsCmd
	global deleteOriginalMapsCmd, deleteOriginalMonitorCmd, deleteOriginalP2pdEarCmd, deleteOriginalSignCmd, deleteOriginalTempCmd, deleteOriginalUninstCmd, deleteOriginalWarCmd, deleteOriginalWebDocCmd

	global originalBinJreDir, originalBinUtilDir, originalCertDir, originalCgiBinDir, originalCogstartupFile, originalCskDir, originalEncryptDir, originalInstLogDir, originalLogsDir
	global originalMapsDir, originalMonitorFile, originalP2pdEarFile, originalProfileCognosDir, originalSignDir, originalTempDir, originalUninstDir, originalWarDir, originalWebDocDir

	global restoreCertsCmd, restoreCertsCmd, restoreCogstartupCmd, restoreCskCmd, restoreEncryptCmd, restoreMonitorCmd, restoreSecurityCmd, restoreSignCmd
 
	wasCognosRootPath = '"'+wasCognosRootPath.replace('/',os.sep)+'"'
	dirList=os.listdir(cognosRootPath)
	profileName = getProfileName(System.getProperty("user.install.root"))
	rc = 0
	errorValue = 0
	for fname in dirList:
		fullFileName=os.path.normpath(cognosRootPath+'/'+fname)
		#backup only directories that do not have a '.backup751.' or '.original751.' in their name
		if ((os.path.isdir(fullFileName)) and (fname.find(".backup") == -1) and (fname.find(".original") == -1)):
			serverDirList.append(fullFileName)
	for originalProfileCognosDir in serverDirList:
		dirName =os.path.basename(originalProfileCognosDir)
		backupDirExtension=getBackupDirectoryType(dirList,dirName)
		print "\n\n==========================================="
		print dirName + " (" + originalProfileCognosDir + ")"
		print "==========================================="
		serverName = os.path.basename(originalProfileCognosDir)

		if os.path.isfile( originalProfileCognosDir.replace('\\',os.sep)+os.sep+"cmplst.txt"):
			print "  Cognos file cmplst.txt found. Proceeding with this directory/server ...\n\n";
			backupRootProfileCognosDir=originalProfileCognosDir+backupDirExtension+dateTimeStamp
			if (System.getProperty("os.name").startswith("Windows")):
				defineWinProperties(dirName)
			else:
				defineNonWinProperties(dirName)
	
			errorValue = upgradeOneServer()
			rc =+ errorValue
			serverName = os.path.basename(originalProfileCognosDir)
		else:
			print "  Cognos file cmplst.txt NOT found. Skipping this directory/server ...\n\n";

	if (errorValue == 0):
		print "    **** INFO: Cognos directory backup and restore for",profileName,"/",serverName,"completed successfully."
	else:
		print "    **** WARN: Cognos directory backup and restore for",profileName,"/",serverName,"completed with errors."
	return rc

def getProfileName(profilePath):
	wasDir = getWASHome()
	wasDir = wasDir.replace('"','')
	profileRegistry = wasDir + '/properties/profileRegistry.xml'
	fh = open(profileRegistry,"r")
	registryLines = fh.readlines()

	for line in registryLines:
		if line.find(profilePath) > -1:
			profileName = line.split()
			profileName = profileName[3].split('=')
			profileName = profileName[1].replace('"','')
			return profileName;
		elif line.find(profilePath.replace('/','\\')) > -1:
			profileName = line.split()
			profileName = profileName[3].split('=')
			profileName = profileName[1].replace('"','')
			return profileName;
#endDef

def getWASHome():
	return getPropertyValue('was.install.root')
#--------------------------------------------------------------------------
# get the profile root
#--------------------------------------------------------------------------	
def getUserInstallRoot():
	return getPropertyValue('user.install.root')
#------------------------------------------------------------------------------
# get the property value by the the property name; If property not available, return ''
#------------------------------------------------------------------------------
def getPropertyValue(propertyName):
	propertyValue = java.lang.System.getProperty(propertyName)
	if(propertyValue == None):
		return ''
	return propertyValue

def checkApplicationExist(applicationName):
	exist = 0
	applications = AdminApp.list().replace(' ','_').split()
	for application in applications:
		if (application == applicationName):
			exist = 1
			return exist
	return exist

def updateApplication(applicationName, newAppLocation):
	# format: AdminApp.update('app1', 'app', '[-operation update -contents c:/apps/app1/newApp1.ear 
	# -usedefaultbindings -nodeployejb -BindJndiForEJBNonMessageBinding 
	# [ ["Increment EJB module" Increment Increment.jar,META-INF/ejb-jar.xml Inc]]]')
	result = 0
	needToUpgradeApp = 0
	print "    applicationName: ",applicationName
	print "    earLocation:     ",newAppLocation
	try:
		AdminApp.update(applicationName, 'app', '[-operation update -contents "' + newAppLocation + '" ]')
	except:
#		Sometimes WAS reports that the application doesn't exist.
#		Actually the application does exist based on the prior application check succeeding.
#
#		Additionally, the version info was found for the given application.
#		NOTE: that there might be an exception generated in the <PROFILE_HOME>/logs/BPMProfileUpgrade.* file.
#		This exception will not be present in the 2nd run.
#
#		type, value, traceback = sys.exc_info()
#		print "                ",type
#		print "                ",value
#		print "                ",traceback
		print "                    CANNOT update the application: " + applicationName
#		result = -1
	else:
		AdminConfig.save()
	return result

#################################################
#                                               #
# Main                                          #
#                                               #
#################################################
profileName = getProfileName(System.getProperty("user.install.root"))
execfile(os.path.normpath(sys.argv[2]+'/config.wbm/MonitorProfileVals.py'))

print "\n\n========================================================================"
print "  Profile Type:                       ",ndType

if not (os.path.isdir(wasCognosRootPath)):
	print "  wasCognosRootPath (DOES NOT exist): ",wasCognosRootPath
else:
	print "  wasCognosRootPath (DOES exist):     ",wasCognosRootPath

if not (os.path.isdir(cognosRootPath)):
	print "  cognosRootPath (DOES NOT exist):    ",cognosRootPath
else:
	print "  cognosRootPath (DOES exist):        ",cognosRootPath

now = time.localtime(time.time())

year   = now[0].toString().replace('/','')
year   = year.replace(':','')

month  = now[1]
if (month < 10 ):
  month = "0"+month.toString().replace('/','')
  month  = month.replace(':','')
else:
  month = month.toString()

day    = now[2]
if (day < 10 ):
  day = "0"+day.toString().replace('/','')
  day    = day.replace(':','')
else:
  day = day.toString()

hour   = now[3]
if (hour < 10 ):
  hour = "0"+hour.toString().replace('/','')
  hour   = hour.replace(':','')
else:
  hour = hour.toString()

minute = now[4]
if (minute < 10 ):
  minute = "0"+minute.toString().replace('/','')
  minute = minute.replace(':','')
else:
  minute = minute.toString()

second = now[5]
if (second < 10 ):
  second = "0"+second.toString().replace('/','')
  second = second.replace(':','')
else:
  second = second.toString()

myDate = year+month+day
myTime = hour+minute+second

dateTimeStamp=myDate+"_"+myTime


print "\n  dateTimeStamp: ", dateTimeStamp
print "    time:          ", now
print "    myDate:        ", myDate
print "    myTime:        ", myTime

serverDirList=[]

wasCognosEarPath = wasCognosRootPath+"/p2pd.ear"
wasCognosEarPath = wasCognosEarPath.replace('/',os.sep)

errorValue = 0
if (ndType == "standalone" or ndType == "managed"):
	if (os.path.isdir(cognosRootPath)):
		errorValue =+ upgradeProfilesCognosServers()

if (errorValue == 0):
	print "\n  **** INFO: Server upgrade(s) for",profileName," completed successfully.\n"
else:
	print "\n  **** WARN: Server upgrade(s) for",profileName," completed with errors.\n"

errorValueApp = 0
if (ndType == "standalone" or ndType == "dmgr"):
	appExists=checkApplicationExist("IBM_Cognos")
	if (appExists == 1):
 		errorValueApp = updateApplication("IBM Cognos", wasCognosEarPath)
if (errorValueApp == 0):
	print "  **** INFO: Cognos Application install for",profileName,"completed successfully."
else:
	print "  **** WARN: Cognos Application install for",profileName," completed with errors."

if ((errorValueApp == 0) and (errorValue == 0)):
	print "\n\n\n\n**** INFO: Full Cognos upgrade for",profileName,"completed successfully.\n\n\n"
else:
	print "\n\n\n\n**** WARN: Full Cognos upgrade for",profileName," completed with errors.\n\n\n"

